--装备图鉴
Lua_EquipAtlasWindow = class("Lua_EquipAtlasWindow", Lua_Window);
function Lua_EquipAtlasWindow:ctor()
    self:superCall("ctor");
    self.showClose = false;
    self.windowName = "Lua_EquipAtlasWindow";
    self.skinName="EquipAtlasWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
end

function Lua_EquipAtlasWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setLocation(-241, 255, 0);
    self.itemIcon:setCanClick(true);

    self.dragList = Lua_DragList.new(self.content,628, 525, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_EquipAtlasCell, 112, 112, 5);
    self.dragList:setCellSpacing(17, 10);
    self.dragList:setLocation(0, -106);


    self.btnInfo = Array();
    self.btnInfo:add({ textStr = LanUtil.getValue(126701), part = 1});
    self.btnInfo:add({ textStr = LanUtil.getValue(126702), part = 2});
    self.btnInfo:add({ textStr = LanUtil.getValue(126703), part = 3});
    self.btnInfo:add({ textStr = LanUtil.getValue(126704), part = 4});

    self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.btnList:setLocation(0, -425, 0);
    self.btnList:setButtonStyle("common_altas_1", "ui_common_tab_02", "ui_common_tab_02", 182, 71, 0.01, 1);
    self.btnList:setButtonText(1, 6, "5C504B", "8B5E34", 30, 30, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
    self.btnList:setButtonLine("common_altas_1", "ui_common_line_013", 0, 0, 0, 0);
    -- self.btnList:setRedPoint(50, 25);
    self.btnList:setButtonItem(163, 71);
    self.btnList:setClickCallBack(self, self.onTabBtnClick);
    self.btnList:setData(self.btnInfo);

    self:addLuaEvent("EQUIP_ATLAS_SELECT_ITEM", self, self.updateSelectAtlasItem);
end

function Lua_EquipAtlasWindow:dispose()
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    if self.btnList ~= nil then
        self.btnList:dispose();
        self.btnList = nil;
    end
    if self.baseAttrInfo ~= nil then
        self.baseAttrInfo:dispose();
        self.baseAttrInfo:clear();
        self.baseAttrInfo = nil;
    end
    self.data = nil;
    if self.btnInfo ~= nil then
        self.btnInfo:dispose();
        self.btnInfo:clear();
        self.btnInfo = nil;
    end
    self:superCall("dispose");
end

function Lua_EquipAtlasWindow:showWin(param)
    self.id = param.id;
    self.btnList:setSelected(param.part);
end

function Lua_EquipAtlasWindow:onTabBtnClick(val)
    if self.selectTabIndex == val then
        return;
    end
    
    self.selectTabIndex = val;
    local part = self.btnInfo[val].part;
    local arr,index = DataCenter.equipUtil:getEquipAtlasInfoByPart(part, self.id);
    self.dragList:setArrayData(arr);
    local moveToIndex = 1;
    if index > 5 then
        moveToIndex = Mathf.Ceil(index/5);
        self.dragList:moveToIndex(moveToIndex);
    end
    self:updateSelectAtlasItem(arr[index])
end

function Lua_EquipAtlasWindow:updateSelectAtlasItem(data)
    if self.selectId == data.data.id then
        return
    end
    self.selectId = data.data.id;
    self:updateShowEquipeInfo(data.data);
    self:updateDrangList();
end

--更新展示
function Lua_EquipAtlasWindow:updateShowEquipeInfo(data)
    self.itemIcon:setData(data);
    self.name.text = data.colorName;
    self.socre.text = data.score;
    self:showBaseAttr(data);
end

-- 属性
function Lua_EquipAtlasWindow:showBaseAttr(data)
    local arr = DataCenter.equipUtil:getEquipAttrInfo(data.id, data.attr_list);
    if self.baseAttrInfo == nil then
        self.baseAttrInfo = Array();
    end
    local len = self.baseAttrInfo:getSize();
    for i = 1, len do
        self.baseAttrInfo[i]:setEnable(false);
    end
    local item;
    for i=1,arr:getSize() do
        if self.baseAttrInfo[i] ~= nil then
            item = self.baseAttrInfo[i];
        else
            item = UICreate.createLabel(self.content, "", 0, 0, 100, 22, 20);
            item.pivot = Lua_WindowUtil.getPivot(0);
            item.alignmentValue = 0;
            item.horizontalOverflowValue = 1;
            item.verticalOverflowValue = 1;
            item.colorStr = Lua_ColorDefine.transColor("459252");
            self.baseAttrInfo:add(item);
        end
        item.text = arr[i].show_name.." +"..arr[i].showValue;
        local x = 0;
        if i%2 == 0 then
            x = 78;
            i = i/2;
        else
            x = -119;
            i =(i+1)/2;
        end
        item:setLocation(x, 261 - (i-1)*30, 0)
        item:setEnable(true);
    end
end


--更新列表选择的材料数量
function Lua_EquipAtlasWindow:updateDrangList()
    if self.dragList ~= nil then
        local arr = self.dragList.showList;
        local len = arr:getSize();
        for i = 1, len do
            arr[i].data.isSelect = arr[i].data.data.id == self.selectId;
            arr[i]:updateSelect();
        end
    end
end











Lua_EquipAtlasCell = class("Lua_EquipAtlasCell", Lua_ListCell);
function Lua_EquipAtlasCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_EquipAtlasCell:buildShowItem()
    self:superCall("buildShowItem");
    
    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setLocation(0, 0, 0);
    self.itemIcon:setCanClick(false);

    self.select_bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_window_014", 0, 0, 117, 117);
    self.select_bg:setEnable(false);
end

function Lua_EquipAtlasCell:setData(data)
    self.data = data;
    self.itemIcon:setData(data.data);
    self:updateSelect()
end

function Lua_EquipAtlasCell:updateSelect()
    if self.data.isSelect == true then
        self.select_bg:setEnable(true);
    else
        self.select_bg:setEnable(false);
    end
end

function Lua_EquipAtlasCell:onPressClick(go)
    Lua_MsgUtil.callFunc("EQUIP_ATLAS_SELECT_ITEM", self.data);
end

function Lua_EquipAtlasCell:dispose()
    self.data = nil;
    self:superCall("dispose");
end