--装备穿戴/更换
Lua_EquipChangeWindow = class("Lua_EquipChangeWindow", Lua_Window);
function Lua_EquipChangeWindow:ctor()
    self:superCall("ctor");
    self.showClose = false;
    self.showBlackMask = true;
    self.isClickClose = true;
    
    self.showWinBg = true;
    self.winBgPath = "/images/common/xui_common_window_002.png";

    self.windowName = "Lua_EquipChangeWindow";
    self.skinName ="EquipChangeWindow_skin";
end

function Lua_EquipChangeWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.showEquipArr = Array();
    local item;
    for i=1,4 do
        item = Lua_EquipChangeItem.new(self.content);
        item:setLocation(-230 + (i-1)*150, 234, 0);
        self.showEquipArr:add(item);
    end

    self.dragList = Lua_DragList.new(self.content,630, 568, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_EquipChangeCell, 630, 144, 1);
    self.dragList:setCellSpacing(6, 6);
    self.dragList:setLocation(0, -146);

    self.goto_txt:setLangValue(126796);
    -- self.goto_txt:addClickFuntion(self, self.onGotoBtnClick);

    self:addLuaEvent("UPDATE_EQUIP_CHANGE", self, self.updateEquipInfo);--英雄穿戴装备更新
    self:addLuaEvent("UPDATE_SELECT_PART", self, self.updateSelectPart);--选中部位
    self:addLuaEvent("CHANGE_SELECT_EQUIP", self, self.changeSelectEquip);--穿戴装备
end

function Lua_EquipChangeWindow:showWin(param)
    self:superCall("showWin",param);
    -- param.part     --选中打开的部位
    -- param.hero_uid --英雄唯一id
    --print(param.part,"    部位          ",param.hero_uid);

    self:updateEquipInfo(param.hero_uid)
end

--更新
function Lua_EquipChangeWindow:updateEquipInfo(hero_uid)
    if hero_uid == self.showData.hero_uid then
        self.hvo = DataCenter.heroData:getItemByUniqueId(hero_uid);
        self.name_txt.text = self.hvo.name..LanUtil.getValue(126776);
        self:showEquipInfo(self.hvo.equipInfo);
    end
    self:updateSelectPart(self.select_part);
end

--装备展示
function Lua_EquipChangeWindow:showEquipInfo(equipInfo)
    for i=1, self.showEquipArr:getSize() do
        self.showEquipArr[i]:setParam(i, self.hvo.level, self.hvo.star);
        self.showEquipArr[i]:setData(equipInfo[i]);
    end
end

--更新装备部位选中
function Lua_EquipChangeWindow:updateSelectPart(part)
    if part == nil then
        part = self.showData.part;
    end
    local cur_equip_uid = self.showEquipArr[part].unique_id;--当前部位的装备Uid
    if cur_equip_uid == nil then
        cur_equip_uid = 0;
    end
    local arr = DataCenter.equipData:getEquipArrByPart(part, cur_equip_uid);
    self.dragList.customParam = cur_equip_uid;
    self.dragList:setArrayData(arr);
    self.dragList:moveToIndex(1,true);
    self.dragList:setEnable(arr:getSize() > 0);
    self.showObj:SetActive(arr:getSize() <= 0);


    --更新选中部位状态
    if self.select_part == part then
        return;
    end
    self.select_part = part;
    for i=1, self.showEquipArr:getSize() do
        self.showEquipArr[i]:updateteSelectPart(part);
    end
end

--穿戴/卸下
function Lua_EquipChangeWindow:changeSelectEquip(list)
    if list.typeof == 1 then--穿戴
        Lua_ProxyManager.getProxy("Lua_EquipProxy"):sWornEquip(list.unique_id, self.hvo.unique_id, list.hero_uid);
    elseif list.typeof == 2 then--卸下
        Lua_ProxyManager.getProxy("Lua_EquipProxy"):sDemountEquip(list.unique_id, self.hvo.unique_id);
    end
end

--跳转
-- function Lua_EquipChangeWindow:onGotoBtnClick()
--     DataCenter.funcPathUtil:gotoFunction(DataCenter.equipUtil.go_to_id, true)
-- end

function Lua_EquipChangeWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end

    if self.showEquipArr ~= nil then
        self.showEquipArr:dispose();
        self.showEquipArr:clear();
        self.showEquipArr = nil;
    end
    self:superCall("dispose");
end

























-- 装备展示item
Lua_EquipChangeItem = class("Lua_EquipChangeItem", Lua_DisplayObject); 
function Lua_EquipChangeItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_EquipChangeItem:buildShowItem()
    self:superCall("buildShowItem");
    self.bg_spr = UICreate.createUIAtlasImage(self.content, "hero_equip_altas", "xui_zb_widget_1_1", 0, 0, 0, 0);
    
    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setScale(0.8,0.8);
    self.itemIcon:setClick(self, self.onIconBtnClick);

    self.select_spr = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_zb_widget_4", 0, 0, 0, 0);
end

function Lua_EquipChangeItem:setParam(part, hvo_level, hvo_star)
    self.part = part;
    self.hvo_star = hvo_star;
    self.hvo_level = hvo_level;
end

--更新选中的part
function Lua_EquipChangeItem:updateteSelectPart(select_part)
    self.select_spr:setEnable(select_part == self.part);
end

function Lua_EquipChangeItem:setData(param)
    self.unique_id = param;
    if param ~= nil then
        self.evo = DataCenter.equipData:getEquipVoByUid(param);
    else
        self.evo = nil;
    end

    local showState = false;
    if self.evo ~= nil then
        self.itemIcon:setData(self.evo);
        self.itemIcon:setShadow(false);
        --替换红点状态
        showState = DataCenter.equipData:checkEquipChangeRedDot(self.part, self.evo.unique_id);
    else
        self.isUnlock = DataCenter.equipUtil:equipPartUnlock(self.part, self.hvo_level, self.hvo_star);
        self.itemIcon:setData(nil);
        self.itemIcon:setShadow(true,"hero_equip_altas", DataCenter.equipUtil:getEquipShadow(self.part, 2));
        self.itemIcon:setIconBg("common_altas_1", "xui_common_itembg_0");
        self.itemIcon:setLock(not self.isUnlock,"runes_atlas","ui_fs_label_01");
        showState = DataCenter.equipData:checkEquipChangeRedDot(self.part, nil);
    end
    self.itemIcon:showNum(0);
    self.itemIcon:showRedPoint(showState);
end

function Lua_EquipChangeItem:onIconBtnClick()
    Lua_MsgUtil.callFunc("UPDATE_SELECT_PART", self.part);
end

function Lua_EquipChangeItem:dispose()
    self.evo = nil;
    self.select_spr = nil;
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self:superCall("dispose");
end

































Lua_EquipChangeCell = class("Lua_EquipChangeCell", Lua_ListCell);
function Lua_EquipChangeCell:ctor(p)
    self:superCall("ctor", p, "EquipChangeCell_skin");
end

function Lua_EquipChangeCell:buildShowItem()
    self:superCall("buildShowItem");
    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setScale(0.8, 0.8);
    self.itemIcon:setLocation(-230, 3, 0);
    self.itemIcon:setCanClick(true);

    self.change_btn:addClickFuntion(self, self.onChangeBtnClick);
end

function Lua_EquipChangeCell:setCustomParam(customParam)
    self.cur_equip_uid = customParam;--当前部位穿戴的装备Uid
    -- print("当前部位穿戴的装备Uid  ",customParam)
end

function Lua_EquipChangeCell:setData(uid)
	self.evo  = DataCenter.equipData:getEquipVoByUid(uid);
	self.name_txt.text = self.evo.name;
	self.socre_txt.text = LanUtil.formateStr(126749,tostring(self.evo.equipScore));

    if self.evo.unique_id == self.cur_equip_uid then--自己穿戴的装备
        self.icon_obj:SetActive(false);
        self.change_btn:setStyle(3);
        self.change_btn:setLangValue(126766);
        self.change_btn:setLocation(223,0,0);
        self.change_btn.txt.colorStr = Lua_ColorDefine.transColorStr("7A6A5F");
    else
        self.change_btn:setStyle(1);
        self.change_btn.txt.colorStr = Lua_ColorDefine.transColorStr("8B5E34");
        if self.evo.hero_uid ~= 0 then --已被穿戴
            self.icon_obj:SetActive(true);
            self.change_btn:setLocation(223,-26,0);
            self.change_btn:setLangValue(126765);
            local hvo = DataCenter.heroData:getItemByUniqueId(self.evo.hero_uid);
            self.icon:setAltas(hvo.atlas, hvo.sprite);
            if hvo.color == 7 then
                self.icon_bj:setAltas("common_altas_1", "xui_common_itembg_19");
            else
                self.icon_bj:setAltas("common_altas_1", "xui_common_itembg_" .. hvo.color);
            end
        else
            if self.cur_equip_uid == 0 then
                self.change_btn:setLangValue(126747);
            else
                self.change_btn:setLangValue(126765);
            end
            self.change_btn:setLocation(223,0,0);
            self.icon_obj:SetActive(false);
        end
    end
    
    self.itemIcon:setData(self.evo);
    self.itemIcon:showNum(0);
    self:showAttr(self.evo.equipProp);
end

-- 基础属性
function Lua_EquipChangeCell:showAttr(equipProp)
    local arr = DataCenter.attributesUtil:getAttrArrByServer(equipProp);
    local item;
    if self.showAttrInfo == nil then
        self.showAttrInfo = Array();
    end

    for i=1, self.showAttrInfo:getSize() do
         self.showAttrInfo[i]:setEnable(false);
    end

    for i=1,arr:getSize() do
        if self.showAttrInfo[i] ~= nil then
            item = self.showAttrInfo[i];
        else
            item  = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 20);
            item.pivotValue = 4;
            item.alignmentValue = 3;
            item.horizontalOverflowValue = 1;
            -- item.fontName = Lua_MyUISettings.fangzhengFontName;
            item.colorStr = Lua_ColorDefine.transColor("74604f");
        end
        item:setEnable(true);
        item.text = arr[i].show_name.."+"..arr[i].showValue;
        item:setLocation(-83 + (i-1)*126, -20, 0);
        self.showAttrInfo:add(item);
    end
end

function Lua_EquipChangeCell:onChangeBtnClick()
    local typeof = 1;--1 更换  2 卸下
    if self.evo.unique_id == self.cur_equip_uid then--自己穿戴的装备
        typeof = 2;
    end
    -- print("typeof = =",typeof,"          unique_id = =",self.evo.unique_id,"          hero_uid = =",self.evo.hero_uid)
	Lua_MsgUtil.callFunc("CHANGE_SELECT_EQUIP", {unique_id = self.evo.unique_id, typeof = typeof, hero_uid = self.evo.hero_uid});
end

function Lua_EquipChangeCell:dispose()
    self.data = nil;
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    if self.showAttrInfo ~= nil then
        self.showAttrInfo:dispose();
        self.showAttrInfo:clear();
        self.showAttrInfo = nil;
    end
    self:superCall("dispose");
end