--装备养成
checkRequire("Lua_EquipRecastPanel");--重铸
-- checkRequire("Lua_EquipRefinePanel");--精炼
checkRequire("Lua_EquipStrongPanel");--强化
Lua_EquipDevelopWindow = class("Lua_EquipDevelopWindow", Lua_Window);
function Lua_EquipDevelopWindow:ctor()
    self:superCall("ctor");
    self.showClose = false;
    self.showBlackMask = true;
    self.isClickClose = true;

    self.showWinBg = true;
    self.winBgPath = "/images/common/xui_common_window_002.png";
    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
    self.windowName = "Lua_EquipDevelopWindow";
    self.skinName="EquipDevelopWindow_skin";
end

function Lua_EquipDevelopWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.panelObjTab = {};
    
    self.tabInfo = Array();
    self.tabInfo:add({textStr = LanUtil.getValue(126750), tagType = 1, panel = Lua_EquipStrongPanel});
    self.tabInfo:add({textStr = LanUtil.getValue(126751), tagType = 2, panel = Lua_EquipRecastPanel});
    --self.tabInfo:add({textStr = LanUtil.getValue(126352), tagType = 3, panel = Lua_EquipRefinePanel});

    self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.btnList:setLocation(-171, -507, 0);
    self.btnList:setButtonItem(133, 77);
    self.btnList:setButtonStyle("common_altas_1","xui_common_tab_002","xui_common_tab_001",133, 77);
    self.btnList:setButtonText(0, 10,"7a6a5f", "8f5123");
    self.btnList:setClickCallBack(self, self.onTabBtnClick);
    self.btnList:setData(self.tabInfo);

    self.help:addClickFuntion(self, self.onHelpBtnClick);

    self:addLuaEvent("UPDATE_EQUIP_STRONG", self, self.updateTabPanel);-- 装备强化
    self:addLuaEvent("UPDATE_EQUIP_DEVELO", self, self.updateTabPanel);-- 装备更新
end

function Lua_EquipDevelopWindow:showWin(param)
    self:superCall("showWin",param);
    self.unique_id = param.unique_id;
    self:updateOpenState();
    self.btnList:setSelected(param.select_type);

end

-- 重铸页签开启状态
function Lua_EquipDevelopWindow:updateOpenState()
    local evo = DataCenter.equipData:getEquipVoByUid(self.unique_id);
    self.bOpenState = evo ~= nil and evo.equipLevel >= DataCenter.equipUtil.recast_open_level;
    self.btnList:setOpenState(2, self.bOpenState);
end 

function Lua_EquipDevelopWindow:onTabBtnClick(val)
    if self.selectTabIndex == val then
        return;
    end

    local tagType = self.tabInfo[val].tagType;
    if tagType == 2 then
        if not self.bOpenState then
            OperateAlert.show(LanUtil.formateStr(126788,DataCenter.equipUtil.recast_open_level));
            return
        end
    end
    -- 隐藏旧的
    self.panel = self.panelObjTab[self.selectTabIndex];
    if self.panel ~= nil then
        self.panel:setEnable(false);
    end
    self.selectTabIndex = val;
    self.panel = self.panelObjTab[val];
    if self.panelObjTab[val] == nil then
        local showPanel = self.tabInfo[val].panel;

        self.panel = showPanel.new(self.content);
        self.panelObjTab[val] = self.panel;
    else
        self.panel:setEnable(true);
    end
    local str;
    
    if tagType == 1 then
        str = LanUtil.getValue(126753);
        self.showTipsDes = LanUtil.getValue(126784);
    elseif tagType == 2 then
        str = LanUtil.getValue(126754);
        self.showTipsDes = LanUtil.getValue(126785);
    elseif tagType == 3 then
        str = LanUtil.getValue(126755);
    end
    self.title_txt.text = str;
    self:updateTabPanel(self.unique_id);
end

function Lua_EquipDevelopWindow:updateTabPanel(unique_id)
    if self.panel ~= nil and self.panel.updatePanel ~= nil and unique_id == self.unique_id then
        self.panel:updatePanel(unique_id);
        if not self.bOpenState then--更新重铸页签开启状态
             self:updateOpenState()
         end
    end
end

function Lua_EquipDevelopWindow:onHelpBtnClick() 
    local tipsData = { des = self.showTipsDes, posX = -55, posY = -445 };
    Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_EquipDevelopWindow:dispose()
    if self.btnList ~= nil then
        self.btnList:dispose();
        self.btnList = nil;
    end

    if self.panelObjTab ~= nil then
        for idx, panelObj in pairs(self.panelObjTab) do
            panelObj:dispose();
            self.panelObjTab[idx] = nil;
        end
        self.panelObjTab = nil;
    end
    self.panel = nil;

    if self.tabInfo ~= nil then
        self.tabInfo:dispose();
        self.tabInfo:clear();
        self.tabInfo = nil;
    end
    self:superCall("dispose");
end