--锻造材料显示
Lua_EquipForgeCell = class("Lua_EquipForgeCell", Lua_ListCell);
function Lua_EquipForgeCell:ctor(p)
    self:superCall("ctor", p,"EquipForgeCell_skin");
end

function Lua_EquipForgeCell:buildShowItem()
    self:superCall("buildShowItem");
    self.change_btn:setEnable(false);

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setLocation(0, 13, 0);
    self.itemIcon:setCanClick(false);
    self.itemIcon:setSiblingIndex(0);

    self.change_btn:addMousDownFuntion(self, self.onMouseDownBtn);
    self.change_btn:addMouseUpFuntion(self,self.onMouseUpBtn);
end

function Lua_EquipForgeCell:setData(data)
	self.data = data;
    self.itemIcon:setData(data.data);
    self.itemIcon:setTypeIcon(data.data.race_camp);
    self.itemIcon:showNum(data.haveNum, false);
    self:updateBtnState();
end

--更新按钮状态
function Lua_EquipForgeCell:updateBtnState()
    -- print("更新按钮状态 -== ",self.data.selectNum)
    if self.data.selectNum >= 1 then
        self.change_btn:setEnable(true);
    else
        self.change_btn:setEnable(false);
    end

    local l = Lua_ColorDefine.getColorStr("459252",self.data.selectNum);
    local r = Lua_ColorDefine.getColorStr("565656", "/"..self.data.haveNum);
    self.num.text = l..r;
end

function Lua_EquipForgeCell:onMouseDownBtn()
	Lua_MsgUtil.callFunc("ON_MOUSE_DOWN_BTN", self.data);
end

--弹起按钮
function Lua_EquipForgeCell:onMouseUpBtn()
    Lua_MsgUtil.callFunc("ON_MOUSE_UP_BTN", self.data);
end

function Lua_EquipForgeCell:onPressClick()
	Lua_MsgUtil.callFunc("ON_FORGE_CELL", self.data);
end

function Lua_EquipForgeCell:onLongPressClick()
    self:onPressClick();

    -- Lua_MsgUtil.callFunc("ON_LONG_FORGE_CELL", self.data);
end

function Lua_EquipForgeCell:dispose()
    self.data = nil;
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self:superCall("dispose");
end