--装备锻造
checkRequire("Lua_EquipForgeCell");
Lua_EquipForgeWindow = class("Lua_EquipForgeWindow", Lua_Window);
function Lua_EquipForgeWindow:ctor()
    self:superCall("ctor");
    self.showClose = false;
    self._isOnClick = false;--点击计时器标识
    self.isOnLongPress = false;--是否长按取消

    self.windowName = "Lua_EquipForgeWindow";
    self.skinName="EquipForgeWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
end

function Lua_EquipForgeWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.show_exp = 0;

    self.showExp:setEnable(false);
    self.forge_btn:setBtnEnable(false);
    self.showDes:setLangValue(126725);

    self.forgeBar:createSecondBar("hero_atlas_2","ui_zb_progress_002_f");
    self.forgeBar:setSecondValue(1);
    self.forgeBar:setValue(0);

    self.itemIconL = Lua_ItemIcon.new(self.showObjL);
    self.itemIconL:setLocation(-150, 247, 0);
    self.itemIconL:setCanClick(true);

    self.itemIconR = Lua_ItemIcon.new(self.showObjR);
    self.itemIconR:setLocation(125, 247, 0);
    self.itemIconR:setCanClick(true);

    self.dragList = Lua_DragList.new(self.content,632, 320, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_EquipForgeCell, 112, 138, 5);
    self.dragList.canLongPress = true;
    self.dragList:setCellSpacing(18, 12);
    self.dragList:setLocation(0, -139);

    self.sub_btn:addClickFuntion(self, self.onSubBtnClick);
    self.help_btn:addClickFuntion(self, self.onHelpBtnClick);
    self.atlas_btn:addClickFuntion(self, self.onAtlasBtnClick);
    self.forge_btn:addClickFuntion(self, self.onForgeBtnClick);
    
    self:addLuaEvent("ON_FORGE_CELL", self, self.updateSelectItem);--选择材料

    self:addLuaEvent("ON_MOUSE_DOWN_BTN", self, self.onMouseDownBtn);--取消选择材料 按下
    self:addLuaEvent("ON_MOUSE_UP_BTN", self, self.onMouseUpBtn);--取消选择材料 弹起

    self:addLuaEvent("UPDATE_EQUIP_FORGE", self, self.updateForgeInfo);--锻造返回
end

function Lua_EquipForgeWindow:showWin(param)
	self:superCall("showWin",param);
    self:updateForgeInfo(param);
end

--初始化数据
function Lua_EquipForgeWindow:initInfo()
    self.selectExp = 0;
	self.allCostExp = nil;
	self.selectNumDic = nil;
	self.tag_cur_equip_id = nil;
end

function Lua_EquipForgeWindow:updateForgeInfo(data)
	if type(data) == "number" then
		self.evo = DataCenter.equipData:getEquipVoByUid(data);
	else
		self.evo = data;
	end
	if self.evo == nil then
		return;
	end
	self:initInfo();
	self.showCostObj:SetActive(false);
	self.isMaxLimit = self.evo.isMaxLevel;--最高品质
	if self.isMaxLimit == true then
		self.isMaxLevel = true;--最大等级标记
		LuaUtil.setObjPos(self.showObjL, 150, -36, 0);
		self.showObjR:SetActive(false);
		self:updateBar(1, 1, 0, false);
	else
		self.isMaxLevel = false;
		local costId = self.evo.consume_item[1][1];
		local tvo = Lua_ToolVo.new(costId);
		self.have_num = DataCenter.packData:getItemCountById(costId);
		self.icon:setAltas(tvo.atlas, tvo.sprite);

		self.showObjR:SetActive(true);

		local next_evo = Lua_EquipVo.new(self.evo.nextEquipId);--下级装备数据
		next_evo.race_id = self.evo.race_id;
		next_evo.hero_uid = self.evo.hero_uid;
		self:updateEquipInfoR(next_evo);
		self:updateForgeCost(self.evo.consume_item[1][2]);
		self:updateBar(self.evo.experience, self.evo.cur_experience, self.evo.cur_experience, false);
	end
	self.forge_btn:setBtnEnable(false);
	--self.selectUidDic -- 可以一键选择材料的uid集合 K-uid V-数量
	local unique_id;
	if self.evo.hero_uid == 0 then
		unique_id = self.evo.unique_id;--从背包打开，锻造材料需要过滤自己本身
	end
	self.showDragArr, self.tagUniqueIdDic, self.selectUidDic = DataCenter.equipData:getShowForgeInfo(unique_id);
	self.dragList:setArrayData(self.showDragArr);

	self:updateEquipInfoL(self.evo,false);
end

--选择数据变化
function Lua_EquipForgeWindow:updateChangeInfo(cur_vo, isBool)
	if isBool == true then --手动选择装备
		self.tag_cur_equip_id = nil;
	end
	--更新进度条
	local add_exp = DataCenter.equipData:getCurProvidExp(self.selectNumDic);--当前提供的经验
	local cost_num = DataCenter.equipData:getForgeCostNum(self.selectNumDic, cur_vo);
	--升级到的id/展示的经验(大于一级是下级已填充充经验，小于一级是当前填充的经验)/--锻造是否满一级/是否最大等级
	self.cur_equid_id, self.show_exp, self.isHowNextBar, isMaxLevel = DataCenter.equipData:getExpToEquipInfo(cur_vo, add_exp);
	-- print("isMaxLevel = =",isMaxLevel)
	local data = Lua_EquipVo.new(self.cur_equid_id);
	data.race_id = self.evo.race_id;
	data.hero_uid = self.evo.hero_uid;
    self.next_equid_id = data.nextEquipId;--下级id

	self:updateForgeCost(cost_num);--花费铜币
	self.showCostObj:SetActive(cost_num > 0);

	if isMaxLevel == true then--到达最大等级
		self.isMaxLevel = true;
		self:updateBar(1, 0, 1, true);
	else
		self.isMaxLevel = false;
		self:updateBar(data.experience, self.evo.cur_experience, self.show_exp, self.isHowNextBar);
		if self.isHowNextBar == true then
			self:updateEquipInfoL(data, true);
		else
			self:updateEquipInfoL(self.evo, false);
		end
		local next_equip_vo = Lua_EquipVo.new(self.next_equid_id);
		next_equip_vo.race_id = self.evo.race_id;
		next_equip_vo.hero_uid = self.evo.hero_uid;
		-- print("self.next_equid_id",self.next_equid_id)
		self:updateEquipInfoR(next_equip_vo);--锻造预览
	end
	self.forge_btn:setBtnEnable(add_exp>0);
	self:updateDrangList();

	if add_exp > 0 then
		self.showExp.text = LanUtil.formateStr(126727, tostring(add_exp));
		self:starTimeControl();
	end
end

--更新列表选择的材料数量
function Lua_EquipForgeWindow:updateDrangList()
    if self.dragList ~= nil then
        local arr = self.dragList.showList;
        local len = arr:getSize();
        for i = 1, len do
            arr[i]:updateBtnState();
        end
    end
end

--动态展示左边锻造后装备数据
function Lua_EquipForgeWindow:updateEquipInfoL(l_vo,bool)
	self.nameL.text = l_vo.name;
	self.itemIconL:setData(l_vo);
	self.itemIconL:setTypeIcon(self.evo.race_camp);
	self.itemIconL:showNum(0, false);
	self:showAttrL(l_vo,bool);
end

--动态展示右边锻造后装备数据
function Lua_EquipForgeWindow:updateEquipInfoR(r_vo)
	self.nameR.text = r_vo.name;
	self.itemIconR:setData(r_vo);
	self.itemIconR:setTypeIcon(self.evo.race_camp);
	self:showAttrR(r_vo);
end















--更新锻造消耗
function Lua_EquipForgeWindow:updateForgeCost(need_num)
    self.need_num = need_num;
    local color = "565656";
    if self.have_num < need_num then
        color = "e01b1b";
    end

    self.num.text ="<color=#"..color..">"..numberTrans(self.have_num).."</color>".."<color=#565656>/"..numberTrans(need_num).."</color>";
    self.num:resetSize();
    self.icon:setLocation(184 - self.num.width / 2, -425, 0);
end

--更新进度条
function Lua_EquipForgeWindow:updateBar(max_value, cur_value, show_value, isShowMax)
	if self.isMaxLevel == true then
		self.forgeBar:setText("Max");
		self.forgeBar:setSecondMaxValue(1);
		self.forgeBar:setSecondValue(1);
		self.forgeBar:setMaxValue(1);
		self.forgeBar:setValue(0);
	else
		self.forgeBar:setText(show_value.."/"..max_value);
		self.forgeBar:setSecondMaxValue(max_value);
		self.forgeBar:setSecondValue(show_value);
		if isShowMax == true then -- 展示超过一级的进度条
			self.forgeBar:setMaxValue(1);
			self.forgeBar:setValue(0);
		else
			self.forgeBar:setMaxValue(max_value);
			self.forgeBar:setValue(cur_value);
		end
	end
end

-- 装备属性
function Lua_EquipForgeWindow:showAttrL(l_vo,bool)
	local arr;
	if bool ~= true then
		arr = DataCenter.attributesUtil:getAttrArrByServer(l_vo.property);
	else
		arr = DataCenter.equipUtil:getEquipAttrInfo(l_vo.equipPropId, l_vo.attr_list);
	end
	
	if self.showAttrArrL == nil then
        self.showAttrArrL = Array();
    end
    local len = self.showAttrArrL:getSize();
    for i = 1, len do
        self.showAttrArrL[i]:setEnable(false);
    end

    local item;
	for i=1,arr:getSize() do
        if self.showAttrArrL[i] ~= nil then
            item = self.showAttrArrL[i];
        else
            item = UICreate.createLabel(self.showObjL, "", 0, 0, 100, 22, 20);
			item.pivot = Lua_WindowUtil.getPivot(4);
			item.alignmentValue = 4;
			item.horizontalOverflowValue = 1;
			item.verticalOverflowValue = 1;
			item.colorStr = Lua_ColorDefine.transColor("459252");
            self.showAttrArrL:add(item);
        end
		item.text = arr[i].show_name.." +"..arr[i].showValue;
		item:setLocation(-150, 172-(i-1)*20,0);
		item:setEnable(true);
	end
end

-- 锻造后属性
function Lua_EquipForgeWindow:showAttrR(r_vo)
    local info = DataCenter.equipUtil:getEquipAttrInfo(r_vo.equipPropId, r_vo.attr_list);
    -- print("锻造后属性  ==",info:getSize())
    if self.showAttrArrR == nil then
        self.showAttrArrR = Array();
    end
    local len = self.showAttrArrR:getSize();
    for i = 1, len do
        self.showAttrArrR[i]:setEnable(false);
    end
    for i = 1, info:getSize() do
        local item = nil;
        if self.showAttrArrR[i] ~= nil then
            item = self.showAttrArrR[i];
        else
        	item = UICreate.createLabel(self.showObjR, "", 0, 0, 100, 22, 20);
			item.pivot = Lua_WindowUtil.getPivot(4);
			item.alignmentValue = 4;
			item.horizontalOverflowValue = 1;
			item.verticalOverflowValue = 1;
			item.colorStr = Lua_ColorDefine.transColor("459252");
            self.showAttrArrR:add(item);
        end
        item.text = info[i].show_name.." +"..info[i].showValue;
        item:setLocation(125, 172-(i-1)*20, 0);
        item:setEnable(true);
    end
end

--飘字
function Lua_EquipForgeWindow:starTimeControl()
	self.moveTime = getTime();
	self.showExp:setEnable(true);
	Lua_CommonUtil.addTimer( "showExpLocation", 0.01, self, self.showExpLocation);
end

--飘字
function Lua_EquipForgeWindow:showExpLocation()
	local endPoy = 120;
	local starPoy = 90;
    local speed = 30;
	local endTime = getTime();
	local moveDistance1 = (endTime - self.moveTime) * speed;
	local movePoy = starPoy + moveDistance1;
	if movePoy >= endPoy then
		self.showExp:setEnable(false);
		Lua_CommonUtil.removeTimer(self, self.showExpLocation);
	else
		self.showExp:setLocation(0, movePoy, 0);
	end
end

--一键填充
function Lua_EquipForgeWindow:onSubBtnClick()
	if self.showDragArr:getSize() == 0 then--没材料
		OperateAlert.showLangValue(126740);
		return
	end

	if self.isMaxLevel == true then--最大等级
		OperateAlert.showLangValue(126724);
		return 
	end

	local isShowTips = true;
	for uid, num in pairs(self.selectUidDic) do
		if isShowTips == true then
	        isShowTips = false;
	    end
    end
	if isShowTips == true then
		OperateAlert.showLangValue(126746);
		return
	end
	self.isHaveSufficientCost = DataCenter.equipData:isOneSelect(self.selectUidDic, self.selectNumDic);--是否可以一键选择
	if self.isHaveSufficientCost == false then--可用材料选择完了
		OperateAlert.showLangValue(126730);
		return
	end

	local need_exp = 0;--当前装备升级需要的经验
	if self.tag_cur_equip_id == nil then--当前需要升级的id
		if self.next_equid_id == nil then--没有手动选择装备
			self.tag_cur_equip_id = self.evo.id;
			need_exp = self.evo.experience - self.evo.cur_experience;
		else
			if self.isHowNextBar == true then--手动选的填充经验已经够一级
				local data = Lua_EquipVo.new(self.cur_equid_id);
				self.tag_cur_equip_id = self.cur_equid_id;
				need_exp = data.experience - self.show_exp;--升到下级需要的经验 - 已填充经验
			else
				self.tag_cur_equip_id = self.evo.id;
				need_exp = self.evo.experience - self.show_exp;
			end
		end

	else
		local data = Lua_EquipVo.new(self.tag_cur_equip_id);
		self.tag_cur_equip_id = data.nextEquipId;--下级装备id
		local data1 = Lua_EquipVo.new(self.tag_cur_equip_id);
		need_exp = data1.experience - self.show_exp;
	end
	
	--选择的材料 uid/数量 --这里计算，当前装备升级到下个等级需要的材料  self.isSelectAllCost--是否选择了所有可用的材料
	self.selectNumDic = DataCenter.equipData:getOneSelectInfo(self.selectNumDic, self.showDragArr, need_exp);
	self:updateChangeInfo(self.evo);
end






















--锻造
function Lua_EquipForgeWindow:onForgeBtnClick()
	if self.selectNumDic == nil  then
		return;
	end
	
	if self.have_num < self.need_num then--材料不够
        DataCenter.packUtil:openPathWindow(self.evo.consume_item[1][1], false);
        return
    end

    local stone_list,equip_list = DataCenter.equipData:getSendSeverForgeInfo(self.selectNumDic, self.tagUniqueIdDic);
	Lua_ProxyManager.getProxy("Lua_EquipProxy"):sForgeEquip(self.evo.unique_id, stone_list, equip_list, self.evo.hero_uid);
	self.selectNumDic = nil;
end

function Lua_EquipForgeWindow:onAtlasBtnClick()
	Lua_WindowUtil.openWin("Lua_EquipAtlasWindow", Lua_WinParam.ACTION_OPEN, {id= self.evo.equipPropId, part = self.evo.part});
end

function Lua_EquipForgeWindow:onHelpBtnClick()
	local tipsData = { des = LanUtil.getValue(126729), posX = 143, posY = -420 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_EquipForgeWindow:dispose()
    if self.itemIconL ~= nil then
        self.itemIconL:dispose();
        self.itemIconL = nil;
    end
    if self.itemIconR ~= nil then
        self.itemIconR:dispose();
        self.itemIconR = nil;
    end
    if self.showAttrArrL ~= nil then
        self.showAttrArrL:dispose();
        self.showAttrArrL:clear();
        self.showAttrArrL = nil;
    end
    if self.showAttrArrR ~= nil then
        self.showAttrArrR:dispose();
        self.showAttrArrR:clear();
        self.showAttrArrR = nil;
    end
    self.evo = nil;
    self.selectNumDic = nil;
    self.tagUniqueIdDic = nil;
	self.showDragArr = nil;
	self.cancel_data = nil
    Lua_CommonUtil.removeTimer(self, self.showExpLocation);
    Lua_CommonUtil.removeTimer(self, self.onCancelSelectItem);
    self:superCall("dispose");
end















--长按取消按钮
function Lua_EquipForgeWindow:onMouseDownBtn(data)
    self:onPress(true, data);
end

--弹起取消按钮
function Lua_EquipForgeWindow:onMouseUpBtn(data)
	-- print(" 弹起取消按钮 ")
    self:onPress(false, data);
end

function Lua_EquipForgeWindow:onPress(state, data)
	self.cancel_data = data;
	if state == true then
		if self._isOnClick == false then
            self._isOnClick = true;
            self.startClickTime = getTime(); -- 记录开始点击时间
            Lua_CommonUtil.addTimer("onCancelSelectItem", 0.01, self, self.onCancelSelectItem);
        end
    else
    	if self._isOnClick == true then
            self._isOnClick = false;
            Lua_CommonUtil.removeTimer(self,self.onCancelSelectItem);
        end
        if self.isOnLongPress == false then
    	   self:cancelSelectItem(data);--取消选择材料
        else
            self.isOnLongPress = false;
        end
    end
end

function Lua_EquipForgeWindow:onCancelSelectItem()
    if getTime() - self.startClickTime > 0.3 then--长按
        self.isOnLongPress = true;
        -- print("00000000000000000000000")
        self:cancelSelectItem(self.cancel_data);
    end
end

--选择材料更新数据
function Lua_EquipForgeWindow:updateSelectItem(data)
	if self.isMaxLevel == true then--最大等级
		OperateAlert.showLangValue(126728);
		return
	end
	local vo = data.data;
	local unique_id = vo.unique_id;

	if self.selectNumDic == nil then
		self.selectNumDic = {};
	end

	if self.selectNumDic[unique_id] == nil then
		self.selectNumDic[unique_id] = 0;
	end
	if self.selectNumDic[unique_id] == data.haveNum then--选择数量到达上限
		OperateAlert.showLangValue(126726);
	else
		self.selectNumDic[unique_id] = self.selectNumDic[unique_id] + 1;
		if self.selectNumDic[unique_id] >= data.haveNum then--选择数量到达上限
			self.selectNumDic[unique_id] = data.haveNum;
		end
		data.selectNum = self.selectNumDic[unique_id];
		self.selectExp = DataCenter.equipData:getSelectCostNum(self.selectNumDic);
		self:updateChangeInfo(self.evo,true);
	end
end

--取消材料选择
function Lua_EquipForgeWindow:cancelSelectItem(data)
	local vo = data.data;
	local unique_id = vo.unique_id;

	if self.selectNumDic[unique_id] == 0 then
		return;
	end

	self.selectNumDic[unique_id] = self.selectNumDic[unique_id] - 1;
	if self.selectNumDic[unique_id] <= 0 then
		data.selectNum = 0;
		self.selectNumDic[unique_id] = nil;
		if self._isOnClick == true then
            self._isOnClick = false;
            Lua_CommonUtil.removeTimer(self,self.onCancelSelectItem);
        end
    else
    	data.selectNum = self.selectNumDic[unique_id];
	end
	
	self.selectExp = DataCenter.equipData:getSelectCostNum(self.selectNumDic);
	self:updateChangeInfo(self.evo,true);
end