--装备重铸
Lua_EquipRecastPanel = class("Lua_EquipRecastPanel", Lua_DisplayObject);
function Lua_EquipRecastPanel:ctor(p)
    self:superCall("ctor", p, "EquipRecastPanel_skin");
end

function Lua_EquipRecastPanel:buildShowItem()
    self:superCall("buildShowItem");
    self.subBtn:setEnable(false);
    self.recastObj:SetActive(false);

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setLocation(-204,213,0);

    self.subBtn:addClickFuntion(self, self.onSubBtnClick);--保存
    self.show_txt:addClickFuntion(self, self.onShowBtnClick);--属性范围
    self.recastBtn:addClickFuntion(self, self.onRecastBtnClick);--重铸

    self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.updateConsInfo);
    self:addLuaEvent("SELECT_EQUIP_ATTR_LCOK", self, self.onSelectAttrLock);-- 装备属性上锁
    self:addLuaEvent("UPDATE_EQUIP_RECAST_INFO", self, self.updateRecastBackInfo);-- 装备重铸
end

function Lua_EquipRecastPanel:updatePanel(equip_uid)
    --print(self.lock_num,"  equip_uid = =",equip_uid);
    self.evo = DataCenter.equipData:getEquipVoByUid(equip_uid);
    if self.evo == nil then
        return
    end

    self.lock_num = self.evo.lockAttrNum;--上锁数量
    -- print(self.lock_num,"  equip_uid = =",equip_uid);
    self.itemIcon:setData(self.evo);
    self.itemIcon:showNum(0);
    self.name_txt.text = self.evo.name;
    self.socre_txt.text = LanUtil.formateStr(126759, tostring(self.evo.equipScore));

    self.recastCostId,self.recastCostNum = DataCenter.equipUtil:getRecastGold(self.evo.equipColorId, 2);
    local tvo = Lua_ToolVo.createToolVo(self.recastCostId);
    self.recastSpr:setAltas(tvo.atlas,tvo.sprite);
    self.recastCostTxt.text = numberTrans(self.recastCostNum);

    self.lock_list = DataCenter.equipUtil:getPropLockLimitById(self.evo.equipColorId);--副属性解锁限制
    
    self:showBaseAttr(self.evo);
    self:showExtraAttr(self.evo);
    self:updateConsInfo();
    self:showRecastFront();

    if self.recast_prop == nil then--进入界面请求一次重铸后界面数据
        -- print(self.evo.unique_id,"   2222222222     ",self.evo.hero_uid)
    	Lua_ProxyManager.getProxy("Lua_EquipProxy"):sRecast(self.evo.unique_id, self.evo.hero_uid);
    end
end
      
--重铸消耗
function Lua_EquipRecastPanel:updateConsInfo()
	local arr = DataCenter.equipUtil:getRecastItemArr(self.evo.equipColorId, self.lock_num);
    if arr == nil then
        return;
    end
   
    if self.recastCostInfo == nil then
        self.recastCostInfo = Array();
    end
    local len = self.recastCostInfo:getSize();
    for i = 1, len do
        self.recastCostInfo[i]:setEnable(false);
    end
    local width = 240;
    local item;
    for i=1, arr:getSize() do
        if self.recastCostInfo[i] ~= nil then
            item = self.recastCostInfo[i];
        else
            item = Lua_EquipRecastCostItem.new(self.content);
            self.recastCostInfo:add(item);
        end
        item:setData(arr[i]);
        item:setLocation(-1 * width * arr:getSize() / 2 + width * (i-1) + width / 2, -344 ,0);
        item:setEnable(true);
    end 
end

--更新重铸后数据
function Lua_EquipRecastPanel:updateRecastBackInfo(msg)
    if tonumber(msg.equip_uid) == self.evo.unique_id then
    	self.recast_prop = msg.recast_prop;
        if self.recast_prop ~= nil and #self.recast_prop > 0 then
            self.subBtn:setEnable(true);
            LuaUtil.setObjPos(self.recastObj,-167, 0, 0);
        else
            self.subBtn:setEnable(false);
            LuaUtil.setObjPos(self.recastObj, 0, 0,0);
        end
        self.recastObj:SetActive(true);
        -- print("更新重铸后数据")
        self:showRecastBack(self.recast_prop);
        self:updateConsInfo();
    end
end

--更新上锁状态
function Lua_EquipRecastPanel:updateLockState(index, state)
    if self.recastFrontInfo ~= nil and self.recastFrontInfo[index] ~= nil then
        self.recastFrontInfo[index]:updateBoxState(state);
    end
end

-- 重铸前
function Lua_EquipRecastPanel:showRecastFront()
    if self.recastFrontInfo == nil then
        self.recastFrontInfo = Array();
    end
    local len = self.recastFrontInfo:getSize();
    for i = 1, len do
        self.recastFrontInfo[i]:setEnable(false);
    end

    local item;
    for i=1, #self.lock_list do
        if self.recastFrontInfo[i] ~= nil then
            item = self.recastFrontInfo[i];
        else
            item = Lua_EquipRecastAttrItem.new(self.content,1);
            self.recastFrontInfo:add(item);
        end
        item:setParam(i, self.lock_list[i]);
        item:setData(self.evo.extraProp[i]);
        item:setLocation(-211, -55 - ( i - 1) * 48, 0);
        item:setEnable(true);
    end 
end

-- 重铸后
function Lua_EquipRecastPanel:showRecastBack(recast_prop)
    if self.recastBackInfo == nil then
        self.recastBackInfo = Array();
    end
    local len = self.recastBackInfo:getSize();
    for i = 1, len do
        self.recastBackInfo[i]:setEnable(false);
    end
    local item;
    for i=1, #self.lock_list do
        if self.recastBackInfo[i] ~= nil then
            item = self.recastBackInfo[i];
        else
            item = Lua_EquipRecastAttrItem.new(self.content,2);
            self.recastBackInfo:add(item);
        end
        item:setParam(i);
        item:setData(recast_prop[i], self.bRecast);
        item:setLocation(126, -55 - ( i - 1) * 48, 0);
        item:setEnable(true);
    end
    self.bRecast = nil;
end

-- 基础属性
function Lua_EquipRecastPanel:showBaseAttr(evo)
    local arr = DataCenter.attributesUtil:getAttrArrByServer(evo.equipProp);
    if self.baseAttrInfo == nil then
        self.baseAttrInfo = Array();
    end
    local len = self.baseAttrInfo:getSize();
    for i = 1, len do
        self.baseAttrInfo[i]:setEnable(false);
    end

    local item;
    for i = 1,arr:getSize() do
        if self.baseAttrInfo[i] ~= nil then
            item = self.baseAttrInfo[i];
        else
            item = Lua_EquipBaseAttrItem.new(self.content,2);
            self.baseAttrInfo:add(item);
        end
        item:setData(arr[i]);
        item:setLocation(-87, 291 - ( i - 1) * 46, 0);
        item:setEnable(true);
    end
end

-- 副属性
function Lua_EquipRecastPanel:showExtraAttr(evo)
    local list = DataCenter.equipUtil:getPropLockLimitById(evo.equipColorId);
    if self.extraAttrInfo == nil then
        self.extraAttrInfo = Array();
    end
    local len = self.extraAttrInfo:getSize();
    for i = 1, len do
        self.extraAttrInfo[i]:setEnable(false);
    end

    local starY = 199;
    local len = self.baseAttrInfo:getSize();
    if len > 0 then
        starY = 291 - len*46;
    end

    local item;
    for i=1, #list do
        if self.extraAttrInfo[i] ~= nil then
            item = self.extraAttrInfo[i];
        else
            item = Lua_EquipExtraAttrItem.new(self.content, 2);
            self.extraAttrInfo:add(item);
        end
        item:setData(evo.extraProp[i], list[i]);
        item:setLocation(-87, starY - ( i - 1) * 46, 0);
        item:setEnable(true);
    end 
end

--上锁
function Lua_EquipRecastPanel:onSelectAttrLock(list)
    if list.lock_state == 1 then
        local unlock_num = #self.evo.extraProp;--解锁个数据
        if unlock_num -1 <= self.lock_num then
            self:updateLockState(list.index, false);
            OperateAlert.showLangValue(126781);
            return
        end
    end
    
    --[上锁索引] = 上锁状态
    if self.lockIndexDic == nil then
        self.lockIndexDic = {};
    end
    self.lockIndexDic[list.index] = list.lock_state;
    Lua_ProxyManager.getProxy("Lua_EquipProxy"):sLockEquipAttr(self.evo.unique_id, self.evo.hero_uid, self.lockIndexDic);
end

--保存
function Lua_EquipRecastPanel:onSubBtnClick()
    self.recast_prop = nil;
	Lua_ProxyManager.getProxy("Lua_EquipProxy"):sRecastSave(self.evo.unique_id, self.evo.hero_uid);
end

--重铸
function Lua_EquipRecastPanel:onRecastBtnClick()
    --金币是否充足
    local need_num = self.recastCostNum;
    local back_num = DataCenter.packData:getItemCountById(self.recastCostId);
    if back_num < need_num then
        DataCenter.packUtil:openPathWindow(self.recastCostId, false);
        return;
    end

    --道具是否充足
    local itemId, need_num = DataCenter.equipUtil:getRecastGold(self.evo.equipColorId, 1);
    back_num = DataCenter.packData:getItemCountById(itemId);
    if back_num < need_num then
        DataCenter.packUtil:openPathWindow(itemId, false);
        return;
    end

    --锁定词条材料道具是否充足
    if self.lock_num > 0 then--有锁定词条
        local tag_id;
        local tag_num;
        local list = DataCenter.equipUtil.lock_entry_jv;--上锁材料消耗
        for i=1,#list do
            back_num = DataCenter.packData:getItemCountById(list[i][1]);
            if back_num < list[i][2] *self.lock_num then
                tag_id = list[i][1];
                tag_num = list[i][1];
                break;
            end
        end

        if tag_id ~= nil then--材料不足
            local bSelect = DataCenter.roleData:getOperationRecord("equip_recast_cost");
            if bSelect == 0 then--没有选择自动购买材料
                local tvo = Lua_ToolVo.createToolVo(tag_id);
                local buy_money_id = tvo.buy_money_id;--消耗道具id；
                local buy_price = tvo.buy_price;--消耗道具数量
                local tipStr = LanUtil.formateStr(126748, tostring(self.lock_num))
                local data = {id = tag_id, limitCount = 0, costId = buy_money_id, 
                costCount = buy_price, tipStr = tipStr, isShowBackBtn = true, sureBtnStr = LanUtil.getValue(125015), 
                owner = self, callFunc = self.onSubBuyClick};
                Lua_WindowUtil.openWin("Lua_ShoppingGoodsWindow", Lua_WinParam.ACTION_OPEN, data);
                return
            else--选择了自动购买
                local tvo = Lua_ToolVo.createToolVo(tag_id);
                back_num = DataCenter.packData:getItemCountById(tvo.buy_money_id);--货币数量
                if back_num < tvo.buy_price*self.lock_num then--货币数量不足
                    DataCenter.packUtil:openPathWindow(tvo.buy_money_id, false);
                    return
                end
            end
        end
    end
    OperateAlert.showLangValue(126790);
    self.bRecast = true;
	Lua_ProxyManager.getProxy("Lua_EquipProxy"):sRecastEquip(self.evo.unique_id, self.evo.hero_uid);
end

--购买返回
function Lua_EquipRecastPanel:onSubBuyClick(buy_money_id, buy_count)
    Lua_ProxyManager.getProxy("Lua_PackProxy"):sPurchaseItem(buy_money_id, buy_count);
end


--副属性预览
function Lua_EquipRecastPanel:onShowBtnClick()
	Lua_WindowUtil.openWin("Lua_EquipExtraAttrWindow", Lua_WinParam.ACTION_OPEN, {equipColorId = self.evo.equipColorId, part = self.evo.part});
end

function Lua_EquipRecastPanel:dispose()
    if self.baseAttrInfo ~= nil then
        self.baseAttrInfo:dispose();
        self.baseAttrInfo:clear();
        self.baseAttrInfo = nil;
    end

    if self.extraAttrInfo ~= nil then
        self.extraAttrInfo:dispose();
        self.extraAttrInfo:clear();
        self.extraAttrInfo = nil;
    end

    if self.recastFrontInfo ~= nil then
        self.recastFrontInfo:dispose();
        self.recastFrontInfo:clear();
        self.recastFrontInfo = nil;
    end

    if self.recastCostInfo ~= nil then
        self.recastCostInfo:dispose();
        self.recastCostInfo:clear();
        self.recastCostInfo = nil;
    end

    if self.recastBackInfo ~= nil then
        self.recastBackInfo:dispose();
        self.recastBackInfo:clear();
        self.recastBackInfo = nil;
    end
    self.recast_prop = nil;
    self.lockIndexDic = nil;
    self:superCall("dispose");
end


























--装备重铸属性
Lua_EquipRecastAttrItem = class("Lua_EquipRecastAttrItem", Lua_DisplayObject);
function Lua_EquipRecastAttrItem:ctor(p, typev)
	self.typev = typev;--1 重铸前  2 重铸后
    self:superCall("ctor", p, "EquipRecastAttrItem_skin");
end

function Lua_EquipRecastAttrItem:buildShowItem()
    self:superCall("buildShowItem");
    self.lock_box:addBoxChange(self, self.onCheckBoxChange);
end

function Lua_EquipRecastAttrItem:updateBoxState(bool)
    self.lock_box.selected = bool;
end

function Lua_EquipRecastAttrItem:setParam(index, limit_lvl)
    self.index = index;
    self.limit_lvl = limit_lvl;
end

--副属性  data : ProtoEquipExtraProp结构体数据
function Lua_EquipRecastAttrItem:setData(data, bRecast)
    local colorStr = "564536";
    if self.typev == 2 then
        colorStr = "469254";
    end

	if data == nil then
		self.lock_box:setEnable(false);
        self.grade_spr:setEnable(false);
        self.attr_txt:setLocation(-33,0,0);
        local str;
        if self.typev == 1 then
            str = LanUtil.formateStr(126780, tostring(self.limit_lvl));
        else
		    str = LanUtil.formateStr(126756, LanUtil.getValue(100 + self.index));
        end

        self.attr_txt.text = Lua_ColorDefine.getColorStr(colorStr, str);
        self:showEffect(false);
	else

        if self.typev == 2 then
            self.lock_box:setEnable(false);
        else
            self.lock_box:setEnable(true);
        	self.lock_box.selected = data.lock_state == 1;--上锁
        end
        local attr_vo = DataCenter.attributesUtil:createAttrVo(data.name);
        if attr_vo == nil then
            return
        end
        local attr = attr_vo.show_name.."+"..DataCenter.equipUtil:getEquipAttrValueStr(data.value, attr_vo.isPercent);
        local str = Lua_ColorDefine.getColorStr(colorStr, attr);
		self.attr_txt.text = str;
        self.attr_txt:setLocation(0,0,0);

        self.grade_spr:setEnable(true);
        self.grade_spr:setAltas("common_altas_3", "xui_zb_label_"..(6+ data.grade));
        
        self:showEffect(bRecast and data.lock_state ~= 1);
	end
end

function Lua_EquipRecastAttrItem:showEffect(bool)
    if bool then
        if self.eff == nil then
            self.eff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_zb_cz_01", "ui_zb_cz_01", 39, 0);
        end
        self.eff:setEnable(false);
        self.eff:setEnable(true);
    else
        if self.eff ~= nil then
            self.eff:setEnable(false);
        end
    end
end

function Lua_EquipRecastAttrItem:onCheckBoxChange(val)
    local lock_state = val and 1 or 0;
    Lua_MsgUtil.callFunc("SELECT_EQUIP_ATTR_LCOK",{index = self.index, lock_state = lock_state});
end

function Lua_EquipRecastAttrItem:dispose()
    if self.eff ~= nil then
        self.eff:dispose();
        self.eff = nil;
    end
    self:superCall("dispose");
end




















--装备重铸消耗
Lua_EquipRecastCostItem = class("Lua_EquipRecastCostItem", Lua_DisplayObject);
function Lua_EquipRecastCostItem:ctor(p)
    self:superCall("ctor", p, "EquipRecastCostItem_skin");
end

function Lua_EquipRecastCostItem:buildShowItem()
    self:superCall("buildShowItem");
    local bSelect = DataCenter.roleData:getOperationRecord("equip_recast_cost") == 1;
    self.select_box.selected = bSelect;
    self.select_box:addBoxChange(self, self.onCheckBoxChange);
end

function Lua_EquipRecastCostItem:setData(data)
	--itemId 道具id, count 消耗数量 , sign 1 正常消耗道具  2 特殊消耗道具
	self.tvo = Lua_ToolVo.createToolVo(data.itemId, data.count);
	local back_num = DataCenter.packData:getItemCountById(data.itemId);
	self.bMeetCost = back_num >= data.count;--材料是否足够
    self.icon_spr:setAltas(self.tvo.atlas, self.tvo.sprite);
	self.select_box:setEnable(data.sign == 2 and self.bMeetCost == false);

	local color = "FFFFFF";
    if not self.bMeetCost then
        color = "FB3131";
    end
    local show_des = back_num.."/"..data.count;
    self.cost_txt.text = Lua_ColorDefine.getColorStr(color, show_des);
end

function Lua_EquipRecastCostItem:onCheckBoxChange(val)
    if val == true then--选中
        local str = LanUtil.formateStr(126757,tostring(self.tvo.buy_price));
        local tipsData = { des = str, btnType = 1, onFunType = 0, owner = self, sureFun = self.sureBtnClick, cancelFun = self.onCancelFun};
        Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
    else
        Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOperate("equip_recast_cost", 0);
    end
end

function Lua_EquipRecastCostItem:onCancelFun()
    self.select_box.selected = false;
end

function Lua_EquipRecastCostItem:sureBtnClick()
    local back_num = DataCenter.packData:getItemCountById(self.tvo.buy_money_id);
    if back_num < self.tvo.buy_price then--钻石数量不足
        DataCenter.packUtil:openPathWindow(self.tvo.buy_money_id, false);
    end
    Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOperate("equip_recast_cost", 1);
end

function Lua_EquipRecastCostItem:dispose()
    self:superCall("dispose");
end