--装备重铸
Lua_EquipRecastWindow = class("Lua_EquipRecastWindow", Lua_Window);
function Lua_EquipRecastWindow:ctor()
    self:superCall("ctor");
    self.showClose = false;
    self.windowName = "Lua_EquipRecastWindow";
    self.skinName="EquipRecastWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
end

function Lua_EquipRecastWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.isHaveMeet = false;--材料是否足够
    self.des:setLangValue(126722);

    self.curRing = 0;--当前跑圈
    self.allRing = DataCenter.equipUtil.all_ring;--总跑圈
    self.runSpeed = DataCenter.equipUtil.run_speed;--速度
    self.decrSpeed =  DataCenter.equipUtil.decr_peed;--递减速度
    self.decrNum =  DataCenter.equipUtil.decr_num;--递减个数

    self.contrBool = false;--计时器开关

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setLocation(-241, 179, 0);
    self.itemIcon:setCanClick(true);

    local siftAllInfo = DataCenter.heroUtil.siftInfo;
    self.siftInfo = Array();
    local len = siftAllInfo:getSize();
    local perWidth = 91;
    for i=1,len do
        local siftItem = Lua_EquipRecastCampSiftItem.new(self.content);
        siftItem:setData(siftAllInfo[i]);
        siftItem:setLocation(-1 * perWidth * len / 2 + perWidth * (i-1) + perWidth / 2, -70, 0);
        self.siftInfo:add(siftItem);
    end

    self.sub_btn:addClickFuntion(self, self.onSubBtnClick);--取消
    self.save_btn:addClickFuntion(self, self.onSaveBtnClick);--保存
    self.recast_btn:addClickFuntion(self, self.onRecastBtnClick);--重铸
    
    self:addLuaEvent("UPDATE_EQUIP_RECAST", self, self.updateEquipRecast);--重铸
    self:addLuaEvent("EQUIP_RECAST_SURE", self, self.updateEquipRecastInfo);--取消/保存
end

function Lua_EquipRecastWindow:showWin(param)
    self.equip_uid = param;
    self:updateEquipRecastInfo();
end

-- 重铸后结果
function Lua_EquipRecastWindow:updateEquipRecast()
    self.evo = DataCenter.equipData:getEquipVoByUid(self.equip_uid);
    self.stop_camp = self.evo.recast_camp;--重铸后种族

    local num = self.stop_camp - self.decrNum;
    if num > 0 then
        self.decrCamp = num;
    else
        self.decrCamp = 6 + self.stop_camp - self.decrNum;
    end
    -- print(self.star_camp,"          ",self.stop_camp," 递减位置  = =",self.decrCamp)
    self:startTimer();
end

-- 更新
function Lua_EquipRecastWindow:updateEquipRecastInfo()
    self.evo = DataCenter.equipData:getEquipVoByUid(self.equip_uid);
    self.star_camp = self.evo.race_camp;--记录重铸前种族

    self.itemIcon:setData(self.evo);
    self.itemIcon:showNum(0);
    self.itemIcon:setTypeIcon(self.evo.race_camp);
    self.name.text = self.evo.colorName;
    local campName = LanUtil.getValue(126050 + self.evo.race_camp);
    self.attr.text = LanUtil.formateStr(126738, campName, tostring(self.evo.prop_add));

    if self.evo.recast_id > 0 then--是否有重铸后id
        self.sub_btn:setEnable(true);
        self.save_btn:setEnable(true);
        self.showDes:setEnable(true);
        self.recast_btn:setEnable(false);
        self:showRecastCost(false);
        self:updateRecastCampSift(self.evo.recast_camp);
    else
        self.sub_btn:setEnable(false);
        self.save_btn:setEnable(false);
        self.showDes:setEnable(false);
        self.recast_btn:setEnable(true);
        self:showRecastCost(true);
        self:updateRecastCampSift(self.evo.race_camp);
    end
end

--种族效果选中
function Lua_EquipRecastWindow:updateRecastCampSift(camp)
    for i=1,self.siftInfo:getSize() do
        if self.siftInfo[i].data == camp then
            self.siftInfo[i]:setSelectEnable(true);
        else
            self.siftInfo[i]:setSelectEnable(false);
        end
    end
end

-- 重铸消耗
function Lua_EquipRecastWindow:showRecastCost(bool)
    if bool == true then
        self.isHaveMeet = true;
        local list = DataCenter.equipUtil.recastConsumeInfo;
        if self.costInfo == nil then
            self.costInfo = Array();
        end
        local item;
        local w = 0;--总宽
        local x = 0;--x坐标
        local itemW = 0;--item宽
        local len = self.costInfo:getSize();
        for i = 1, len do
            self.costInfo[i]:setEnable(false);
        end
        for i = 1, #list do
            if self.costInfo[i] ~= nil then
                item = self.costInfo[i];
            else
                item = Lua_EquipRecastCostItem.new(self.costObj);
                self.costInfo:add(item);
            end
            local space = i == 1 and 0 or itemW/2+40;--间距
            item:setEnable(true);
            item:setData(list[i]);
            itemW = item.itemW;
            w = itemW + w + space;
            x = x + itemW/2 + space;
            item:setLocation(x, -298, 0);
            
            if item.isHaveMeet ~= true then
                self.isHaveMeet = item.isHaveMeet;
            end
        end
        -- print(w,"   ",self.costInfo[1].itemW/2)
        LuaUtil.setObjPos(self.costObj, -w/2 + self.costInfo[1].itemW/4, 0, 0);
    else
        if self.costInfo ~= nil then
            local len = self.costInfo:getSize();
            for i = 1, len do
                self.costInfo[i]:setEnable(false);
            end
        end
    end
end

function Lua_EquipRecastWindow:startTimer()
    if self.contrBool == false then
        self.contrBool = true;
        self.change_camp = self.star_camp;
        self.starTime = getTime();
        self:addTimer("updateRecastEffect", 0.01, self, self.updateRecastEffect);
    end
end

function Lua_EquipRecastWindow:endTimer()
    self.contrBool = false;
    self:removeTimer(self, self.updateRecastEffect);
end


function Lua_EquipRecastWindow:updateRecastEffect()
    if getTime() - self.starTime < self.runSpeed then
        return;
    end
    self.starTime = getTime();
    
    self.change_camp = self.change_camp + 1;
    if self.change_camp > 6 then
        self.change_camp = 1;
    end

    if self.change_camp == self.star_camp then --跑圈记录
        self.curRing = self.curRing + 1;--跑了一圈
    end

    if self.curRing >= self.allRing - 1 then--最后一圈
        if self.isDecr == nil and self.change_camp == self.decrCamp then--触发递减
            self.isDecr = true;
        end
    end

    if self.isDecr == true then
        self.runSpeed = self.runSpeed + self.decrSpeed;
    end

    if self.isDecr == true and self.change_camp == self.stop_camp then
        self.isDecr = nil;
        self:endTimer();
        self.curRing = 0;
        self.runSpeed = 0.05;--速度
        self:updateEquipRecastInfo();
    end

    self:updateRecastCampSift(self.change_camp);
end

function Lua_EquipRecastWindow:onRecastBtnClick()
    if self.contrBool == true or self.evo.recast_id ~= 0 then--效果播放中
        return
    end
    if self.isHaveMeet ~= true then
        DataCenter.packUtil:openPathWindow(self.isHaveMeet, false);
        return;
    end
    
    Lua_ProxyManager.getProxy("Lua_EquipProxy"):sRecastEquip(self.equip_uid, self.evo.hero_uid);
end


--取消效果
function Lua_EquipRecastWindow:onSubBtnClick()
    Lua_ProxyManager.getProxy("Lua_EquipProxy"):sSaveRecastResult(self.equip_uid, 2, self.evo.hero_uid);
    OperateAlert.showLangValue(126731);
end

--保存效果
function Lua_EquipRecastWindow:onSaveBtnClick()
    if self.evo.recast_id > 0 then--保存重铸效果
        Lua_ProxyManager.getProxy("Lua_EquipProxy"):sSaveRecastResult(self.equip_uid, 1, self.evo.hero_uid);
    end
end


function Lua_EquipRecastWindow:dispose()
    if self.siftInfo ~= nil then
        self.siftInfo:dispose();
        self.siftInfo:clear();
        self.siftInfo = nil;
    end
    if self.costInfo ~= nil then
        self.costInfo:dispose();
        self.costInfo:clear();
        self.costInfo = nil;
    end
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self:endTimer();
    self.isDecr = nil;
    self.equip_uid = nil;
    self:superCall("dispose");
end














--种族效果展示
Lua_EquipRecastCampSiftItem = class("Lua_EquipRecastCampSiftItem", Lua_CampSiftBaseItem); 
function Lua_EquipRecastCampSiftItem:ctor(p) 
    self:superCall("ctor", p);
end

function Lua_EquipRecastCampSiftItem:buildShowItem()
    self.select_bg = UICreate.createUIAtlasImage(self.content, "hero_atlas_2", "ui_zb_window_008", 0, -3, 0, 0);
    self.select_bg:setEnable(false);
    self:superCall("buildShowItem");
    self.icon_bg:setEnable(false);
end

function Lua_EquipRecastCampSiftItem:setSelectEnable(bool)
    self.select_bg:setEnable(bool);
     local spr;
    if bool then
        spr = "ui_common_button_0"..25 + self.data.."_p";
    else
        spr = "ui_common_button_0"..25 + self.data.."_n";
    end
    self.show_icon:setAltas("common_altas_2", spr);
end

function Lua_EquipRecastCampSiftItem:dispose()
    self:superCall("dispose");
end



















-- 重铸消耗动态显示item
Lua_EquipRecastCostItem = class("Lua_EquipRecastCostItem", Lua_DisplayObject);
function Lua_EquipRecastCostItem:ctor(p)
    self:superCall("ctor", p,"EquipRecastCostItem_skin");
end

function Lua_EquipRecastCostItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_EquipRecastCostItem:setData(list)
    self.tvo = Lua_ToolVo.createToolVo(list[1], list[2]);
    local bagNum = DataCenter.packData:getItemCountById(self.tvo.id);
    if bagNum < self.tvo.count then
        bagNum = "<color=#e01b1b>"..numberTrans(bagNum).."</color>";
    else
        bagNum = numberTrans(bagNum);
    end
    local str = bagNum.."/"..numberTrans(self.tvo.count);
    self.cost_value.text = "<color=#565656>"..str.."</color>";
    self.cost_value:resetSize();
    self.cost_icon:setAltas(self.tvo.atlas, self.tvo.sprite);

    LuaUtil.setObjPos(self.showObj, -self.itemW/2, 0, 0);
end

--材料是否足够
function Lua_EquipRecastCostItem.Get:isHaveMeet()
    if self.tvo ~= nil then
        local bagNum = DataCenter.packData:getItemCountById(self.tvo.id);
        if bagNum >= self.tvo.count then
            return true;
        else
            return self.tvo.id;
        end
    end
    return false;
end

function Lua_EquipRecastCostItem.Get:itemW()
    return 40 + self.cost_value.width;
end

function Lua_EquipRecastCostItem:dispose()
    self:superCall("dispose");
end