--强化大师panel基类
Lua_EquipStrongMasterBasePanel = class("Lua_EquipStrongMasterBasePanel", Lua_DisplayObject);
function Lua_EquipStrongMasterBasePanel:ctor(p)
    self:superCall("ctor", p, "EquipStrongMasterBasePanel_skin");
end

function Lua_EquipStrongMasterBasePanel:buildShowItem()
    self:superCall("buildShowItem");

    self.showEquipArr = Array();
    local item;
    for i=1,4 do
        item = Lua_EquipMasterEquipItem.new(self.content);
        item:setPart(i);
        item:setLocation(-232+(i-1)*150, 242, 0);
        self.showEquipArr:add(item);
    end
end

function Lua_EquipStrongMasterBasePanel:updatePanel(hero_uid)
    
end

function Lua_EquipStrongMasterBasePanel:showLeftAttr(arr)
    if arr == nil then
        return;
    end
    if self.leftAttrInfo == nil then
        self.leftAttrInfo = Array();
    end
    local len = self.leftAttrInfo:getSize();
    for i = 1, len do
        self.leftAttrInfo[i]:setEnable(false);
    end

    local item;
    for i=1, arr:getSize() do
        if self.leftAttrInfo[i] ~= nil then
            item = self.leftAttrInfo[i];
        else
            item = Lua_EquipMasterAttrItem.new(self.content, 1);
            self.leftAttrInfo:add(item);
        end
        item:setData(arr[i]);
        item:setLocation(-169, -33 - ( i - 1) * 44, 0);
        item:setEnable(true);
    end 
end

function Lua_EquipStrongMasterBasePanel:showRightAttr(arr)
    if arr == nil then
        return;
    end
    if self.rightAttrInfo == nil then
        self.rightAttrInfo = Array();
    end
    local len = self.rightAttrInfo:getSize();
    for i = 1, len do
        self.rightAttrInfo[i]:setEnable(false);
    end

    local item;
    for i=1, arr:getSize() do
        if self.rightAttrInfo[i] ~= nil then
            item = self.rightAttrInfo[i];
        else
            item = Lua_EquipMasterAttrItem.new(self.content, 2);
            self.rightAttrInfo:add(item);
        end
        item:setData(arr[i]);
        item:setLocation(165, -33 - ( i - 1) * 44, 0);
        item:setEnable(true);
    end 
end

function Lua_EquipStrongMasterBasePanel:dispose()
	if self.showEquipArr ~= nil then
        self.showEquipArr:dispose();
        self.showEquipArr:clear();
        self.showEquipArr = nil;
    end

    if self.leftAttrInfo ~= nil then
        self.leftAttrInfo:dispose();
        self.leftAttrInfo:clear();
        self.leftAttrInfo = nil;
    end

    if self.rightAttrInfo ~= nil then
        self.rightAttrInfo:dispose();
        self.rightAttrInfo:clear();
        self.rightAttrInfo = nil;
    end

    self:superCall("dispose");
end
















--属性
Lua_EquipMasterAttrItem = class("Lua_EquipMasterAttrItem", Lua_DisplayObject);
function Lua_EquipMasterAttrItem:ctor(p, typev)
	self.typev = typev;
    self:superCall("ctor", p, "EquipMasterAttrItem_skin");
end

function Lua_EquipMasterAttrItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_EquipMasterAttrItem:setData(att_vo)
	self.name_txt.text = att_vo.show_name;
	local color = "564536";
	local value = att_vo.showValue;
	if self.typev == 2 then
		color = "439354";
		value = att_vo.showNextValue;
	end
	self.value_txt.text = Lua_ColorDefine.getColorStr(color, value);
	self.icon_spr:setAltas("common_altas_2",att_vo.attr_icon_2);
end

function Lua_EquipMasterAttrItem:dispose()
	self:superCall("dispose");
end




















-- 装备展示item
Lua_EquipMasterEquipItem = class("Lua_EquipMasterEquipItem", Lua_DisplayObject); 
function Lua_EquipMasterEquipItem:ctor(p)
    self:superCall("ctor", p,  "EquipMasterEquipItem_skin");
end

function Lua_EquipMasterEquipItem:buildShowItem()
    self:superCall("buildShowItem");
    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setScale(0.8, 0.8);
    self.itemIcon:setClick(self, self.onIconBtnClick);
end

function Lua_EquipMasterEquipItem:setPart(part)
    self.part = part;
end

function Lua_EquipMasterEquipItem:setData(unique_id, typev)
	--typev 1:强化大师  2:装备共鸣
    self.evo = DataCenter.equipData:getEquipVoByUid(unique_id);
    if self.evo ~= nil then
        self.itemIcon:setData(self.evo);
        self.itemIcon:setShadow(false);
        self.value_txt:setEnable(true);
        self.bar:setEnable(true);
        if typev == 1 then
            self.bar:setMaxValue(DataCenter.equipUtil.strong_master_max_id);
            self.bar:setValue(self.evo.equipLevel);

            self.value_txt.fontSize = 20;
            self.value_txt.fontName = Lua_MyUISettings.defaultFontName;
            self.value_txt.effectStyle = 2;
            self.value_txt.colorStr = Lua_ColorDefine.transColor("FFFFFF");
            self.value_txt.effectColorStr = Lua_ColorDefine.transColor("000000");
	    	self.value_txt.text = self.evo.equipLevel.."/"..DataCenter.equipUtil.strong_master_max_id;
	    else
            local cur_value = DataCenter.equipUtil:color_value(self.evo.equipColorId);
            local max_value = DataCenter.equipUtil:color_value(DataCenter.equipUtil.equip_color_max_id);
            self.bar:setMaxValue(max_value);
            self.bar:setValue(cur_value);

            self.value_txt.fontSize = 22;
            self.value_txt.fontName = Lua_MyUISettings.fangzhengFontName;
            self.value_txt.effectStyle = 2;
            self.value_txt.colorStr = Lua_ColorDefine.transColor("ffe588");
            self.value_txt.effectColorStr = Lua_ColorDefine.transColor("2a263d");
            local str = DataCenter.equipUtil:color_name(DataCenter.equipUtil.equip_color_max_id);
	    	self.value_txt.text = DataCenter.equipUtil:color_name(self.evo.equipColorId).."/"..str;
	    end
    else
        self.bar:setEnable(false);
        self.value_txt:setEnable(false);
        self.itemIcon:setData(nil);
        self.itemIcon:setShadow(true,"hero_equip_altas", DataCenter.equipUtil:getEquipShadow(self.part, 2));
        self.itemIcon:setIconBg("common_altas_1", "xui_common_itembg_0");
    end
end

function Lua_EquipMasterEquipItem:dispose()
    self.evo = nil;
    self.value_txt = nil;
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self:superCall("dispose");
end
