--装备强化大师
checkRequire("Lua_EquipMasterPanel");--强化大师
checkRequire("Lua_EquipResonancePanel");--装备共鸣
Lua_EquipStrongMasterWindow = class("Lua_EquipStrongMasterWindow", Lua_Window);
function Lua_EquipStrongMasterWindow:ctor()
    self:superCall("ctor");
    self.showClose = false;
    self.isClickClose = true;
    self.showBlackMask = true;
    
    self.showWinBg = true;
    self.winBgPath = "/images/common/xui_common_window_002.png";

    self.windowName = "Lua_EquipStrongMasterWindow";
    self.skinName= "EquipStrongMasterWindow_skin";
end

function Lua_EquipStrongMasterWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.panelObjTab = {};
    
    self.tabInfo = Array();
    self.tabInfo:add({textStr = LanUtil.getValue(126767), tagType = 1, panel = Lua_EquipMasterPanel});
    self.tabInfo:add({textStr = LanUtil.getValue(126768), tagType = 2, panel = Lua_EquipResonancePanel});

    self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.btnList:setLocation(-171, -507, 0);
    self.btnList:setButtonItem(133, 77);
    self.btnList:setButtonStyle("common_altas_1","xui_common_tab_002","xui_common_tab_001",133, 77);
    self.btnList:setButtonText(0, 10,"7a6a5f", "8f5123");
    self.btnList:setClickCallBack(self, self.onTabBtnClick);
    self.btnList:setData(self.tabInfo);

    self.help:addClickFuntion(self, self.onHelpBtnClick);
end

function Lua_EquipStrongMasterWindow:showWin(param)
    self:superCall("showWin",param);
    self.unique_id = param.unique_id;
    self.btnList:setSelected(param.select_type);
end

function Lua_EquipStrongMasterWindow:onTabBtnClick(val)
    if self.selectTabIndex == val then
        return;
    end
    -- 隐藏旧的
    self.panel = self.panelObjTab[self.selectTabIndex];
    if self.panel ~= nil then
        self.panel:setEnable(false);
    end
    self.selectTabIndex = val;
    self.panel = self.panelObjTab[val];
    if self.panelObjTab[val] == nil then
        local showPanel = self.tabInfo[val].panel;
        self.panel = showPanel.new(self.content);
        self.panelObjTab[val] = self.panel;
    else
        self.panel:setEnable(true);
    end
    local str;
    local tagType = self.tabInfo[val].tagType;
    if tagType == 1 then
        str = LanUtil.getValue(126767);
        self.showTipsDes = LanUtil.getValue(126786);
    elseif tagType == 2 then
        str = LanUtil.getValue(126768);
        self.showTipsDes = LanUtil.getValue(126787);
    end
    self.title_txt.text = str;
    if self.panel ~= nil and self.panel.updatePanel ~= nil then
        self.panel:updatePanel(self.unique_id);
    end
end

function Lua_EquipStrongMasterWindow:onHelpBtnClick() 
    local tipsData = { des = self.showTipsDes, posX = -55, posY = -445 };
    Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_EquipStrongMasterWindow:dispose()
    if self.btnList ~= nil then
        self.btnList:dispose();
        self.btnList = nil;
    end

    if self.panelObjTab ~= nil then
        for idx, panelObj in pairs(self.panelObjTab) do
            panelObj:dispose();
            self.panelObjTab[idx] = nil;
        end
        self.panelObjTab = nil;
    end
    self.panel = nil;

    if self.tabInfo ~= nil then
        self.tabInfo:dispose();
        self.tabInfo:clear();
        self.tabInfo = nil;
    end
    self:superCall("dispose");
end