--装备强化
checkRequire("Lua_EquipBaseAttrItem");
checkRequire("Lua_EquipExtraAttrItem")
Lua_EquipStrongPanel = class("Lua_EquipStrongPanel", Lua_DisplayObject);
function Lua_EquipStrongPanel:ctor(p)
    self:superCall("ctor", p, "EquipStrongPanel_skin");
end

function Lua_EquipStrongPanel:buildShowItem()
    self:superCall("buildShowItem");
    self._isOnClick = false;--点击计时器标识
    self.isOnLongPress = false;--是否长按取消

    self.goto_txt:setLangValue(126796);

    self.forgeBar.typeValue = 3;
    self.forgeBar.fillMethodValue = 0;
    self.forgeBar.fillOrigin = 0;
    self.forgeBar:createSecondBar("common_altas_3","xui_common_tipsprogress_005_f");
    self.forgeBar:setSecondValue(1);
    self.forgeBar:setValue(0);

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setLocation(-204,213,0);

    self.dragList = Lua_DragList.new(self.content,632, 280, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_EquipStrongCell, 119, 119, 5);
    self.dragList.canLongPress = true;
    self.dragList:setCellSpacing(6, 6);
    self.dragList:setLocation(7, -140);

    -- self.goto_txt:addClickFuntion(self, self.onGotoBtnClick);--前往获取
    self.tips_txt:addClickFuntion(self, self.onTipsBtnClick);--前往背包
    self.selectBtn:addClickFuntion(self, self.onSelectBtnClick);--快速选择
    self.strongBtn:addClickFuntion(self, self.onStrongBtnClick);--确认强化

    self:addLuaEvent("ON_MOUSE_UP_BTN", self, self.onMouseUpBtn);--取消选择材料 弹起
    self:addLuaEvent("ON_MOUSE_DOWN_BTN", self, self.onMouseDownBtn);--取消选择材料 按下
    self:addLuaEvent("PACK_ITEMS_UPDATE",self, self.updateShowDrag);
    self:addLuaEvent("ON_SELECT_STRING_CELL", self, self.updateSelectItem);--选择材料
    self:addLuaEvent("UPDATE_EQUIP_STRONG", self, self.showStrongEffect);-- 装备强化返回

    self:addLuaEvent("MONEY_UPDATE", self, self.onItemUpdate);
    self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.onItemUpdate);
end

function Lua_EquipStrongPanel:updatePanel(equip_uid)
    self.evo = DataCenter.equipData:getEquipVoByUid(equip_uid);
    if self.evo == nil then
        return
    end

    self.itemIcon:setData(self.evo);
    self.itemIcon:showNum(0);
    self.name_txt.text = self.evo.name;
    self.socre_txt.text = LanUtil.formateStr(126759, tostring(self.evo.equipScore));

    self.right_level_txt:setEnable(false);
    self.left_level_txt.text = "+"..self.evo.equipLevel;

    self.selectNumDic = nil;
    self.strong_level = self.evo.equipLevel;
    self.record_level_id = self.evo.equipLevelId;
    self.show_equip_exp = self.evo.equipCurLevelExp;--装备当前等级展示的经验（进度条展示的经验）
    self.upgrade_need_exp = DataCenter.equipUtil:getEquipUpgradeExp(self.record_level_id) - self.show_equip_exp;--当前等级升级需要的经验
    self:updateStrongBar();
    self:updateShowDrag();
    self:showBaseAttr(self.evo);
    self:showExtraAttr(self.evo);
end

--更新数量
function Lua_EquipStrongPanel:updateShowDrag()
    self.showDragArr = DataCenter.equipData.strongStoneInfo;
    self.dragList:setArrayData(self.showDragArr);
    self.tips_txt:setEnable(self.showDragArr:getSize() <= 0);
    self.dragList:setEnable(self.showDragArr:getSize() > 0);
    self.showObj:SetActive(self.showDragArr:getSize() <= 0);
end

--长按取消按钮
function Lua_EquipStrongPanel:onMouseDownBtn(tvo)
    self:onPress(true, tvo);
end

--弹起取消按钮
function Lua_EquipStrongPanel:onMouseUpBtn(tvo)
    -- print(" 弹起取消按钮 ")
    self:onPress(false, tvo);
end

function Lua_EquipStrongPanel:onPress(state, tvo)
    self.cancel_data = tvo;
    if state == true then
        if self._isOnClick == false then
            self._isOnClick = true;
            self.startClickTime = getTime(); -- 记录开始点击时间
            Lua_CommonUtil.addTimer("onCancelSelectItem", 0.01, self, self.onCancelSelectItem);
        end
    else
        if self._isOnClick == true then
            self._isOnClick = false;
            Lua_CommonUtil.removeTimer(self,self.onCancelSelectItem);
        end
        if self.isOnLongPress == false then
           self:cancelSelectItem(tvo);--取消选择材料
        else
            self.isOnLongPress = false;
        end
    end
end

function Lua_EquipStrongPanel:onCancelSelectItem()
    if getTime() - self.startClickTime > 0.3 then--长按
        self.isOnLongPress = true;
        -- print("00000000000000000000000")
        self:cancelSelectItem(self.cancel_data);
    end
end

--选择材料更新数据
function Lua_EquipStrongPanel:updateSelectItem(tvo)
    if DataCenter.equipUtil:getEquipExp(self.record_level_id) <= 0 then--最大等级
        OperateAlert.showLangValue(126728);
        return
    end

    if self.selectNumDic == nil then
        self.selectNumDic = {};
    end

    if self.selectNumDic[tvo.tag_uid] == nil then
        self.selectNumDic[tvo.tag_uid] = 0;
    end
    if self.selectNumDic[tvo.tag_uid] == tvo.count then--选择数量到达上限
        OperateAlert.showLangValue(126758);
    else
        self.selectNumDic[tvo.tag_uid] = self.selectNumDic[tvo.tag_uid] + 1;
        if self.selectNumDic[tvo.tag_uid] > tvo.count then--选择数量到达上限
            self.selectNumDic[tvo.tag_uid] = tvo.count;
        end
        self:updateChangeInfo(self.selectNumDic);
    end
end

--取消材料选择
function Lua_EquipStrongPanel:cancelSelectItem(tvo)
    if self.selectNumDic[tvo.tag_uid] == 0 then
        return;
    end

    self.selectNumDic[tvo.tag_uid] = self.selectNumDic[tvo.tag_uid] - 1;
    if self.selectNumDic[tvo.tag_uid] <= 0 then
        self.selectNumDic[tvo.tag_uid] = nil;
        if self._isOnClick == true then
            self._isOnClick = false;
            Lua_CommonUtil.removeTimer(self,self.onCancelSelectItem);
        end
    end
    
    self:updateChangeInfo(self.selectNumDic);
end

--选择数据变化
function Lua_EquipStrongPanel:updateChangeInfo(selectNumDic)
    --更新
    self.selectExp = DataCenter.equipUtil:getSelectCostExp(selectNumDic);
    if self.selectExp >= self.upgrade_need_exp then --选择的经验够升一级;
        local record_level;
        self.show_equip_exp, record_level = DataCenter.equipUtil:getEquipStrongLevelAndLeftExp(self.evo.equipCurLevelExp, self.evo.equipLevelId, self.selectExp);
        self.record_level_id = self.evo.id *100 + record_level;
        self.strong_level = record_level;
    else
        self.strong_level = self.evo.equipLevel;
        self.record_level_id = self.evo.equipLevelId;
        self.show_equip_exp = self.evo.equipCurLevelExp + self.selectExp;
    end

    self:showBaseAttr(self.evo,self.strong_level);
    self:showExtraAttr(self.evo,self.strong_level);
    self:updateDrangList();
    self:updateStrongBar();
end

--更新展示
function Lua_EquipStrongPanel:updateStrongBar()
    if DataCenter.equipUtil:getEquipExp(self.record_level_id) <= 0 then--最大等级
        self.forgeBar:setSecondMaxValue(1);
        self.forgeBar:setSecondValue(1);
        self.forgeBar:setMaxValue(1);
        self.forgeBar:setValue(0);
        self.forgeBar:setText(LanUtil.getValue(126761));
        if self.strong_level > self.evo.equipLevel then
            self.costObj:SetActive(true);
            self.right_level_txt:setEnable(true);
            self.right_level_txt.text = "+"..self.strong_level;
        else
            self.costObj:SetActive(false);
            self.right_level_txt:setEnable(false);
        end
    else
        local all_exp = DataCenter.equipUtil:getEquipUpgradeExp(self.record_level_id);
        local str = self.show_equip_exp.."/"..all_exp;
        self.forgeBar:setMaxValue(all_exp);
        self.forgeBar:setSecondMaxValue(all_exp);
        self.forgeBar:setSecondValue(self.show_equip_exp);
        self.forgeBar:setText(str);
        
        if self.strong_level > self.evo.equipLevel then
            self.forgeBar:setValue(0);
            self.right_level_txt:setEnable(true);
            self.right_level_txt.text = "+"..self.strong_level;
        else
            self.forgeBar:setValue(self.evo.equipCurLevelExp);
            self.right_level_txt:setEnable(false);
        end

        self.costObj:SetActive(true);
    end

    local tvo = Lua_ToolVo.createToolVo(Lua_ResourcesDefine.GOLD);
    local back_num = DataCenter.packData:getItemCountById(Lua_ResourcesDefine.GOLD);
    local cost_num = DataCenter.equipUtil:getStrongCostCoinNum(self.evo.equipColorId, self.selectNumDic);
    self.icon_spr:setAltas(tvo.atlas, tvo.sprite);

    self.bCanStrong = back_num >= cost_num;--是否可以强化
    local color = "FFFFFF";
    if not self.bCanStrong then
        color = "ee2c24";
    end
    self.cost_txt.text = Lua_ColorDefine.getColorStr(color, numberTrans(back_num).."/"..numberTrans(cost_num));
    self.cost_txt:resetSize();

    local w = self.cost_txt.width;
    self.cost_spr:SetDimensions(w +38, 32);
    self.icon_spr:setLocation(-17 - w/2 ,0,0)
end

function Lua_EquipStrongPanel:updateDrangList()
    if self.dragList ~= nil then
        local arr = self.dragList.showDragDataList;
        local len = arr:getSize();
        for i = 1, len do
            arr[i].data.tag_unm = self.selectNumDic[arr[i].data.tag_uid];
            if arr[i].cell ~= nil then
                arr[i].cell:updateBtnState();
            end
        end
    end
end

-- 基础属性
function Lua_EquipStrongPanel:showBaseAttr(evo, strong_level)
    if strong_level == nil then
        strong_level = self.evo.equipLevel;
    end
    local arr = DataCenter.attributesUtil:getAttrArrByServer(evo.equipProp);
    if self.baseAttrInfo == nil then
        self.baseAttrInfo = Array();
    end
    local len = self.baseAttrInfo:getSize();
    for i = 1, len do
        self.baseAttrInfo[i]:setEnable(false);
    end

    local item;
    for i = 1,arr:getSize() do
        if self.baseAttrInfo[i] ~= nil then
            item = self.baseAttrInfo[i];
        else
            item = Lua_EquipBaseAttrItem.new(self.content, 1);
            self.baseAttrInfo:add(item);
        end
        item:setData(arr[i]);
        item:showBaseStrong(evo.id, strong_level, self.evo.equipLevel);
        item:setLocation(-87, 291 - ( i - 1) * 46, 0);
        item:showEffect(false);
        item:setEnable(true);
    end
end

-- 副属性
function Lua_EquipStrongPanel:showExtraAttr(evo, strong_level)
    local list = DataCenter.equipUtil:getPropLockLimitById(evo.equipColorId);
    if self.extraAttrInfo == nil then
        self.extraAttrInfo = Array();
    end
    local len = self.extraAttrInfo:getSize();
    for i = 1, len do
        self.extraAttrInfo[i]:setEnable(false);
    end
    local starY = 199;
    local len = self.baseAttrInfo:getSize();
    if len > 0 then
        starY = 291 - len*46;
    end

    local item;
    for i=1, #list do
        if self.extraAttrInfo[i] ~= nil then
            item = self.extraAttrInfo[i];
        else
            item = Lua_EquipExtraAttrItem.new(self.content, 1);
            self.extraAttrInfo:add(item);
        end
        item:setData(evo.extraProp[i], list[i]);
        item:showStrong(strong_level);
        item:setLocation(-87, starY - ( i - 1) * 46, 0);
        item:setEnable(true);
    end 
end

--强化特效
function Lua_EquipStrongPanel:showStrongEffect()
    if self.eff == nil then
        self.eff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_zb_zbqh_0001", "ui_zb_zbqh_0001", -204, 213);
    end
    self.eff:setEnable(false);
    self.eff:setEnable(true);

    if self.baseAttrInfo ~= nil then
        for i=1, self.baseAttrInfo:getSize() do
            self.baseAttrInfo[i]:showEffect(true);
        end
    end
end


--快速选择
function Lua_EquipStrongPanel:onSelectBtnClick()
    if self.showDragArr:getSize() == 0 then--没材料
        OperateAlert.showLangValue(126740);
        return;
    end

    if DataCenter.equipUtil:getEquipExp(self.record_level_id) <= 0 then--最大等级
        OperateAlert.showLangValue(126762);
        return;
    end
    if self.selectNumDic == nil then
        self.selectNumDic = {};
    end

    local need_exp = DataCenter.equipUtil:getEquipUpgradeExp(self.record_level_id) - self.show_equip_exp;
    -- print("升满一级需要的经验 = =", need_exp)
    self.selectNumDic = DataCenter.equipUtil:updateSelectStrongNumDic(need_exp, self.showDragArr, self.selectNumDic);--需要选择的强化石
    self:updateChangeInfo(self.selectNumDic);
end

function Lua_EquipStrongPanel:onStrongBtnClick()
    if DataCenter.equipUtil:getEquipExp(self.record_level_id) <= 0 and self.strong_level == self.evo.equipLevel then--最大等级
        OperateAlert.showLangValue(126762);
        return 
    end

    if self.selectNumDic == nil  then
        return;
    end

    local bStrong = false
    for id, count in pairs(self.selectNumDic) do
        if count > 0 then
            bStrong = true;
            break;
        end
    end

    if bStrong == false then--未选择强化石材料
        OperateAlert.showLangValue(126764);
        return;
    else
        if self.bCanStrong ~= true then--金币不足
            DataCenter.packUtil:openPathWindow(Lua_ResourcesDefine.GOLD, false);
            return;
        end
    end
    Lua_ProxyManager.getProxy("Lua_EquipProxy"):sStrongEquip(self.evo.unique_id, self.evo.hero_uid, self.selectNumDic);
end

-- function Lua_EquipStrongPanel:onGotoBtnClick()
--     DataCenter.packUtil:openPathWindow(Lua_ResourcesDefine.GOLD, false);
-- end

function Lua_EquipStrongPanel:onTipsBtnClick()
    DataCenter.funcPathUtil:gotoFunction(1020);
end

function Lua_EquipStrongPanel:onItemUpdate(dic)
    if self.evo == nil or dic == nil or dic[Lua_ResourcesDefine.GOLD] == nil then return end

    self:updateStrongBar();
end

function Lua_EquipStrongPanel:dispose()
    if self.baseAttrInfo ~= nil then
        self.baseAttrInfo:dispose();
        self.baseAttrInfo:clear();
        self.baseAttrInfo = nil;
    end

    if self.extraAttrInfo ~= nil then
        self.extraAttrInfo:dispose();
        self.extraAttrInfo:clear();
        self.extraAttrInfo = nil;
    end

    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    self.selectNumDic = nil;
    Lua_CommonUtil.removeTimer(self, self.onCancelSelectItem);
    self:superCall("dispose");
end





















--强化材料展示
Lua_EquipStrongCell = class("Lua_EquipStrongCell", Lua_ListCell);
function Lua_EquipStrongCell:ctor(p)
    self:superCall("ctor", p,"EquipStrongCell_skin");
end

function Lua_EquipStrongCell:buildShowItem()
    self:superCall("buildShowItem");
    self.change_btn:setEnable(false);

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setScale(0.96, 0.96);
    self.itemIcon:setCanClick(false);
    self.itemIcon:setSiblingIndex(0);

    self.change_btn:addMousDownFuntion(self, self.onMouseDownBtn);
    self.change_btn:addMouseUpFuntion(self,self.onMouseUpBtn);
end

function Lua_EquipStrongCell:setData(data)
    self.data = data;
    self.itemIcon:setData(data);
    self.itemIcon:showNum(0);
    self:updateBtnState();
end

--更新按钮状态
function Lua_EquipStrongCell:updateBtnState()
    -- print("更新按钮状态 -== ",self.data.selectNum)
    if self.data.tag_unm ~= nil and self.data.tag_unm > 0 then
        self.itemIcon:setMask(true);
        self.change_btn:setEnable(true);
        self.num_txt.text = self.data.tag_unm.."/"..self.data.count;
    else
        self.itemIcon:setMask(false);
        self.change_btn:setEnable(false);
        self.num_txt.text = "0/"..self.data.count;
    end
end

function Lua_EquipStrongCell:onMouseDownBtn()
    Lua_MsgUtil.callFunc("ON_MOUSE_DOWN_BTN", self.data);
end

--弹起按钮
function Lua_EquipStrongCell:onMouseUpBtn()
    Lua_MsgUtil.callFunc("ON_MOUSE_UP_BTN", self.data);
end

function Lua_EquipStrongCell:onPressClick()
    Lua_MsgUtil.callFunc("ON_SELECT_STRING_CELL", self.data);
end

function Lua_EquipStrongCell:onLongPressClick()
    self:onPressClick();

    -- Lua_MsgUtil.callFunc("ON_LONG_FORGE_CELL", self.data);
end

function Lua_EquipStrongCell:dispose()
    self.data = nil;
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self:superCall("dispose");
end