--装备tips
Lua_EquipTipsWindow = class("Lua_EquipTipsWindow", Lua_Window);
function Lua_EquipTipsWindow:ctor()
    self:superCall("ctor");

    self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
    self.windowName = "Lua_EquipTipsWindow";
    self.skinName = "EquipTipsWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
end

function Lua_EquipTipsWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.starBgH = 306;--背景初始高度
    self.bgHight = 643;--背景总高度

    self.socreNum = Lua_NumberImage.new(self.showObj);
	self.socreNum:setLocation(-76, 177.5, 0);
	self.socreNum.pivot = 1;
	self.socreNum.numOffsetX = -4;
	self.socreNum.numAtlas = "number";
	self.socreNum.preStr = "xui_zl1_number_0";

    self.itemIcon = Lua_ItemIcon.new(self.showObj);
    self.itemIcon:setLocation(-196, 210, 0);
    self.itemIcon:setScale(0.8, 0.8);

    self.lock_btn:addClickFuntion(self, self.onLockBtnClick);--锁定
    self.show_btn:addClickFuntion(self, self.onShowBtnClick);--副属性预览
    
    self:addLuaEvent("UPDATE_EQUIP_LOCK", self, self.updateEquipTips);
end

function Lua_EquipTipsWindow:dispose()
    if self.baseAttrInfo ~= nil then
        self.baseAttrInfo:dispose();
        self.baseAttrInfo:clear();
        self.baseAttrInfo = nil;
    end

    if self.extraAttrInfo ~= nil then
        self.extraAttrInfo:dispose();
        self.extraAttrInfo:clear();
        self.extraAttrInfo = nil;
    end
    
    if self.redDotIcon ~= nil then
        self.redDotIcon:dispose();
        self.redDotIcon = nil;
    end
    if self.btnArr ~= nil then
        self.btnArr:dispose();
        self.btnArr:clear();
        self.btnArr = nil;
    end
    self.evo = nil;
    self.itemIcon = nil;
    if self.socreNum ~= nil then
	    self.socreNum:dispose()
	    self.socreNum = nil;
	end
    self:superCall("dispose");
    Lua_MsgUtil.callFunc("ITEM_DETAILS_CLOSE");
end

function Lua_EquipTipsWindow:showWin(param)
	self:superCall("showWin",param);

	self.initH = 204;--初始高度已经默认计算上主属性宽度
	self.addH = 0;--主属性默认高度
	self.evo = param.data;
	self.isShowBtns = param.isShowBtns; --17
	self.btnType = param.btnType;

	self.des_txt.text = self.evo.des;
	self.des_txt:resetSize();
	local color = Lua_ColorDefine.getItemColorStr(self.evo.color, true);
	self.name_txt.text = Lua_ColorDefine.getColorStr(color, self.evo.name);
	self.socreNum.num = self.evo.equipScore;
	
	self.part_txt.text = DataCenter.equipUtil:getEquipPartName(self.evo.part);
	self.winBg:setAltas("common_altas_2", "xui_common_itembg_"..(self.evo.color + 6));

	--主属性
	self:showBaseAttr(self.evo);

	--副属性
	self:showExtraAttr(self.evo);
	local len = self.extraAttrInfo:getSize();
	if len > 0 then
		self.extraObj:SetActive(true);
		local space1 = 10;--副属性文本 到 词条间隔
		local space2 = 32;--属性词条 到 文本描述间隔
		local addH = len*43 + space1 + space2;
		self.addH = self.addH + addH;
		LuaUtil.setObjPos(self.downObj, 0, -addH, 0);
	else
		local space = 10;--主属性文本 到 描述风险间隔
		self.addH = self.addH + space;
		self.extraObj:SetActive(false);
		LuaUtil.setObjPos(self.downObj, 0, -space, 0);
	end

	local des_h = self.des_txt.height;
	self.addH = self.addH + des_h + 10;

	if self.isShowBtns then
		--按钮
		local list;
		if self.btnType == 1 then -- 英雄详情展示界面
			list = {10, 11}; -- 更换 卸下
		else
			if self.evo.hero_uid == 0 then--背包
				list = {12, 6}; --强化 穿戴 
			else
				list = {12, 10, 11}; -- 强化 更换 卸下
			end
		end
		local btn_h = self:showButtonList(list, des_h);
		self.addH = self.addH + btn_h;--按钮高度
	end
	self.winBg:SetDimensions(544, self.initH + self.addH);

	self:updateEquipTips();
end

function Lua_EquipTipsWindow:updateEquipTips(unique_id)
	if unique_id ~= nil and self.evo.unique_id == unique_id then
		self.evo = DataCenter.equipData:getEquipVoByUid(unique_id);
		if Lua_WindowUtil.isWindowShowing("Lua_PackBatchWindow") == true then--上锁状态改变 更新装备分解
			Lua_MsgUtil.callFunc("PACK_BATCH_UPDATE_SELECT", tonumber(unique_id));
		end
	end

	self.itemIcon:setData(self.evo);
	self.itemIcon:showNum(0);
	if self.evo.unique_id == nil or self.evo.unique_id == 0 or (not self.evo.bSelfRole) then
		self.lock_btn:setEnable(false);
		self.lock_txt:setEnable(false);
		self.itemIcon:setEquipLock(false);
	else
		self.lock_btn:setEnable(true);
		self.lock_txt:setEnable(true);
		self.lock_txt.text = self.evo.lockState and LanUtil.getValue(126778) or LanUtil.getValue(126779);
	end
end

-- 基础属性
function Lua_EquipTipsWindow:showBaseAttr(evo)
	local arr = DataCenter.attributesUtil:getAttrArrByServer(evo.equipProp);
	local isServerInfo = true;--是否是服务端数据
	if arr:getSize() == 0 then
		isServerInfo = false;
		local id = evo.id * 100 + evo.equipLevel;
		local propDic = DataCenter.equipUtil:getEquipProp(id);
		arr = DataCenter.attributesUtil:getAttrArrByDic(propDic);--配置表数据
	end

	if self.baseAttrInfo == nil then
        self.baseAttrInfo = Array();
    end
    local len = self.baseAttrInfo:getSize();
    for i = 1, len do
        self.baseAttrInfo[i]:setEnable(false);
    end

    local item;
	for i = 1,arr:getSize() do
        if self.baseAttrInfo[i] ~= nil then
            item = self.baseAttrInfo[i];
        else
            item = Lua_EquipTipsBaseAttrItem.new(self.showObj);
            self.baseAttrInfo:add(item);
        end
        item:setData(arr[i]);
		item:setLocation(-233 + ( i - 1) * 220, 92, 0);
		item:setEnable(true);
	end
end

-- 副属性
function Lua_EquipTipsWindow:showExtraAttr(evo)
	local list = DataCenter.equipUtil:getPropLockLimitById(evo.equipColorId);
	local extraProp = evo.extraProp;
	if self.extraAttrInfo == nil then
        self.extraAttrInfo = Array();
    end
    local len = self.extraAttrInfo:getSize();
    for i = 1, len do
        self.extraAttrInfo[i]:setEnable(false);
    end

    local data;
    local item;
	for i=1, #list do
		if self.extraAttrInfo[i] ~= nil then
            item = self.extraAttrInfo[i];
        else
            item = Lua_EquipTipsExtraAttrItem.new(self.extraObj);
            self.extraAttrInfo:add(item);
        end
        data = nil;
        if extraProp ~= nil then
        	data = extraProp[i];
        end
        item:setData(data, list[i], evo.part, evo.color, evo.star);
		item:setLocation(-233, 12 - ( i - 1) * 37, 0);
		item:setEnable(true);
	end
end

-- 更新
function Lua_EquipTipsWindow:showRedDotInfo()
 --    if self.hero_uid ~= nil and self.isShowBtns == true then
 --    	local heroVo = DataCenter.heroData:getItemByUniqueId(self.hero_uid);--上阵英雄展示锻造红点
	--     --锻造红点状态
	--     local showState = DataCenter.equipData:checkEquipForgeRedDot(data);
	--     self:showRedDot(showState and heroVo.isShowFight == true);
	-- end
	
end

--锻造红点
-- function Lua_EquipTipsWindow:showRedDot(val)
--     if val == true then
--         if self.redDotIcon == nil then
--             self.redDotIcon = Lua_RedPointIcon.new(self.content);
--             self.redDotIcon:setLocation(64, self.bgHight/2 - self.winBg.height + 39.5 - 32, 0);
--             self.redDotIcon:createRedPointImg(nil);
--         end
--         self.redDotIcon:updateRedPointShow(true);
--     else
--         if self.redDotIcon ~= nil then
--             self.redDotIcon:updateRedPointShow(false);
--         end
--     end
-- end

function Lua_EquipTipsWindow:showButtonList(list, des_h)
    if not self.isShowBtns then
        return 0;
    end
    local space = 16;--按钮到装备描述之间的距离
    des_h = des_h + space;
    if self.btnArr == nil then
        self.btnArr = Array();
    end
    local arr = Array();
    local obj;
	if list ~= nil then
	    for i = 1, #list do
	        obj = list[i];
	        if self.evo.expired_tick ~= nil and self.evo.expired_tick > 0 then
	            if self.evo.isExpired then
	                if obj == 4 then
	                    arr:add(obj);
	                end
	            else
	                if obj ~= 4 then
	                    arr:add(obj);
	                end
	            end
	        else
	            arr:add(obj);
	        end
	    end
	end

    local num = arr:getSize();
    local len = self.btnArr:getSize();
    local maxLen = num > len and num or len;
    local btn;

    local startX;
    local intervalX;
    local intervalY = -66;
    local count;
    if num == 1 then
        startX = 0;
        intervalX = 0;
        count = 1;
    elseif num == 2 then
        startX = -138;
        intervalX = 276;
        count = 2;
    elseif num == 3 then
        startX = -172;
        intervalX = 172;
        count = 3;
    elseif num == 4 then
        startX = -138;
        intervalX = 276;
        count = 2;
    elseif num == 5 then
        startX = -172;
        intervalX = 172;
        count = 3;
    elseif num == 6 then
        startX = -172;
        intervalX = 172;
        count = 3;
    end    

    local posX;
    local posY;
    for i = 1, maxLen do
        btn = self.btnArr[i];
        if i > num then
            if btn ~= nil then
                btn:setEnable(false);
            end
        else
            if btn == nil then
                btn = UICreate.createButton(self.downObj, nil, 0, 0, 141, 54);
                btn:setStyle(14);
                btn.txt:setLocation(0, 0, 0);
                btn.txt.fontSize = 28;
                self.btnArr:add(btn);
            else
                btn:setEnable(true);
            end
            
            if arr[i] == 12 then
            	btn:setLangValue(309078);
            else
				btn:setLangValue(309010 + arr[i]);
			end
			btn.name = tostring(arr[i]);
            posX = startX + ((i - 1) % count) * intervalX;
            posY = 40 - des_h + Mathf.Floor((i - 1) / count) * intervalY;
            if num == 5 and i == num then
                posX = posX + intervalX;
            end
            btn:setLocation(posX, posY, 0);
            btn:addClickFuntion(self, self.onButtonClick);
        end
    end

    if num < 4 then
        return 54 + space;
    end
    return 160;
end

function Lua_EquipTipsWindow:onButtonClick(go)
	if tonumber(go.name) == 6 then -- 穿戴
		DataCenter.funcPathUtil:gotoFunction(1033, true)
	elseif tonumber(go.name) == 10 then -- 更换
		Lua_WindowUtil.openWin("Lua_EquipChangeWindow", Lua_WinParam.ACTION_OPEN, {part = self.evo.part, hero_uid = self.evo.hero_uid});
	elseif tonumber(go.name) == 11 then -- 卸下
		Lua_ProxyManager.getProxy("Lua_EquipProxy"):sDemountEquip(self.evo.unique_id, self.evo.hero_uid);
	elseif tonumber(go.name) == 12 then -- 强化
		Lua_WindowUtil.openWin("Lua_EquipDevelopWindow", Lua_WinParam.ACTION_OPEN, {unique_id = self.evo.unique_id, select_type = 1});
	end
	self:hide();
end

--锁定
function Lua_EquipTipsWindow:onLockBtnClick()
	local lock_state = 1;
	if self.evo.lockState then
		lock_state = 0;
	end
	Lua_ProxyManager.getProxy("Lua_EquipProxy"):sLockEquip(self.evo.unique_id, self.evo.hero_uid, lock_state);
end

--副属性预览
function Lua_EquipTipsWindow:onShowBtnClick()
	Lua_WindowUtil.openWin("Lua_EquipExtraAttrWindow", Lua_WinParam.ACTION_OPEN, {equipColorId = self.evo.equipColorId, part = self.evo.part});
end































--装备基础属性
Lua_EquipTipsBaseAttrItem = class("Lua_EquipTipsBaseAttrItem", Lua_DisplayObject);
function Lua_EquipTipsBaseAttrItem:ctor(p)
    self:superCall("ctor", p, "EquipTipsBaseAttrItem_skin");
end

function Lua_EquipTipsBaseAttrItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_EquipTipsBaseAttrItem:setData(att_vo)
	self.attr_txt.text = "<color=#edeef7>"..att_vo.show_name.." </color><color=#52b16b> +"..att_vo.showValue.."</color>";
	self.icon_spr:setAltas("common_altas_2",att_vo.attr_icon_2);
end

function Lua_EquipTipsBaseAttrItem:dispose()
	self:superCall("dispose");
end















--装备副属性
Lua_EquipTipsExtraAttrItem = class("Lua_EquipTipsExtraAttrItem", Lua_DisplayObject);
function Lua_EquipTipsExtraAttrItem:ctor(p)
    self:superCall("ctor", p, "EquipTipsExtraAttrItem_skin");
end

function Lua_EquipTipsExtraAttrItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_EquipTipsExtraAttrItem:setData(serverInfo, limit_lvl, part, color, star)
	if serverInfo == nil then --副属性词条未解锁
		self.grade_spr:setEnable(false);
		self.attr_txt:setLocation(22, 1, 0);
		self.icon_spr:setAltas("common_altas_2", "ui_common_ce_03");
		local str = LanUtil.formateStr(126780,tostring(limit_lvl));
		self.attr_txt.text = Lua_ColorDefine.getColorStr("9f9f9f",str);
	else
		local attr_vo = DataCenter.attributesUtil:createAttrVo(serverInfo.name);
		if attr_vo == nil then
			return
		end
		self.grade_spr:setEnable(true);
		self.attr_txt:setLocation(60, 1, 0);
		self.grade_spr:setAltas("common_altas_3", "xui_zb_label_"..(6+serverInfo.grade));
		self.icon_spr:setAltas("common_altas_2", attr_vo.attr_icon_2);
		local equip_entry_id = DataCenter.equipUtil:getEquipEntryId(part, color, star, attr_vo.id);

		local valueList = DataCenter.equipUtil:getAttrValueLsit(equip_entry_id);--属性范围
		local show_value = DataCenter.equipUtil:getEquipAttrValueStr(serverInfo.value, attr_vo.isPercent);
		local show_str1 = DataCenter.equipUtil:getEquipAttrValueStr(valueList[1], attr_vo.isPercent);
		local show_str2 = DataCenter.equipUtil:getEquipAttrValueStr(valueList[2], attr_vo.isPercent);
		
		self.attr_txt.text = "<color=#edeef7>"..attr_vo.show_name.."</color> <color=#52b16b>+"..show_value.." ("..show_str1.."~"..show_str2..")".."</color>";
	end
end

function Lua_EquipTipsExtraAttrItem:dispose()
	self:superCall("dispose");
end