--合成材料选择
Lua_RunesCompoundCostWindow = class("Lua_RunesCompoundCostWindow", Lua_Window);
function Lua_RunesCompoundCostWindow:ctor()
    self:superCall("ctor");
    self.showBlackMask = true;
    self.isClickClose = true;
    self.windowName = "Lua_RunesCompoundCostWindow";
    self.skinName = "RunesCompoundCostWindow_skin";
end

function Lua_RunesCompoundCostWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.dragList = Lua_DragList.new(self.content, 600, 370, Lua_AxisDefine.Vertical);
    self.dragList:setLocation(3, 56);
    self.dragList:setListCell(Lua_RunesCompoundCostCell, 107, 107, 5);
    self.dragList:setCellSpacing(14, 14);
    self.dragList.canLongPress = true;

    self.sub_btn:addClickFuntion(self, self.onSubBtnClick);
 
    self:addLuaEvent("ON_SELECT_COST_ITEM", self, self.updateSelecCosttItem);--选择材料
end

function Lua_RunesCompoundCostWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self.window_list = nil;
    self:superCall("dispose");
end

function Lua_RunesCompoundCostWindow:showWin(param)
    self.select_num, self.select_color, arr = DataCenter.runesData:getRunesCostInfo(param);
    self.window_list = {};
    for k,v in pairs(param) do
    	self.window_list[k] = v;
    end
    self.dragList:setArrayData(arr);
    self:showNone(arr == nil or arr:getSize() <= 0);
    self:updateShowNum(self.select_num);
end

function Lua_RunesCompoundCostWindow:showNone(bShow)
	if bShow then
		if self.noneIcon == nil then
			self.noneIcon = UICreate.createUIAtlasImage(self.content, "common_altas_3", "ui_liaotian_widget_002", 0, 35, 648, 119);
			self.noneIcon:setScale(0.8, 0.8, 0.8);
		end
		self.noneIcon:setEnable(true);

		if self.noneText == nil then
			self.noneText = UICreate.createLabel(self.content, LanUtil.getValue(126853), 0, 35, 100, 40, 30);
			self.noneText.pivot = UIUtils.Pivot.Center;
			self.noneText.fontName = Lua_MyUISettings.huakangFontName;
			self.noneText.alignmentValue = 4;
			self.noneText.horizontalOverflowValue = 1;
			self.noneText.colorStr = Lua_ColorDefine.transColorStr("9F928C");
		end
		self.noneText:setEnable(true);
	else
		if self.noneIcon ~= nil then
			self.noneIcon:setEnable(false);
		end
		if self.noneText ~= nil then
			self.noneText:setEnable(false);
		end
	end
end

--更新选择的材料数量
function Lua_RunesCompoundCostWindow:updateShowNum(num)
    self.show_num.text = LanUtil.formateStr(126832, tostring(num), tostring(DataCenter.runesUtil.put_runes_max))
end

--选择材料更新数据
function Lua_RunesCompoundCostWindow:updateSelecCosttItem(data)
	local rvo = DataCenter.runesData:getRunesVoByUid(data.unique_id);
	if self.select_color == nil then--当前未选择过任何品质材料
		self.select_color = rvo.color;
		self.select_num = 1;
		data.isSelect = true;
		self.window_list[data.unique_id] = 1;
	else
		if self.select_num >= DataCenter.runesUtil.put_runes_max and self.window_list[data.unique_id] == nil then--材料已满足
			OperateAlert.showLangValue(126827);
			return
		end

		if self.select_color ~= rvo.color then--请选择同类型符文
			OperateAlert.showLangValue(126826);
			return
		end

		if data.isSelect == true then
			data.isSelect = false;
			self.select_num = self.select_num - 1;
			self.window_list[data.unique_id] = nil;
		else
			data.isSelect = true;
			self.select_num = self.select_num + 1;
			self.window_list[data.unique_id] = 1;
		end
		if self.select_num == 0 then
			self.select_color = nil;
		end
	end
	self:updateShowNum(self.select_num);
	self:updateDrangList();
end

--更新列表选择的材料数量
function Lua_RunesCompoundCostWindow:updateDrangList()
    if self.dragList ~= nil then
        local arr = self.dragList.showList;
        local len = arr:getSize();
        for i = 1, len do
            arr[i]:updateBtnState();
        end
    end
end

function Lua_RunesCompoundCostWindow:onSubBtnClick()
    Lua_MsgUtil.callFunc("UPDATE_COST_SELECT_INFO",self.window_list);
    self:hide();
end





















--合成材料
Lua_RunesCompoundCostCell = class("Lua_RunesCompoundCostCell", Lua_ListCell);
function Lua_RunesCompoundCostCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_RunesCompoundCostCell:buildShowItem()
    self:superCall("buildShowItem");

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setScale(0.86, 0.86);

    self.select_mask = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_common_label_14", 0, 0, 0, 0);
    self.select_mask:setScale(0.86, 0.86, 0.86);
end

function Lua_RunesCompoundCostCell:dispose()
    self.data = nil;
    self.rvo = nil;
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self:superCall("dispose");
end

function Lua_RunesCompoundCostCell:setData(data)
	self.data = data;
	self.rvo = DataCenter.runesData:getRunesVoByUid(data.unique_id);
    self.itemIcon:setData(self.rvo);
    self.itemIcon:showNum(0);
    self:updateBtnState();
end

-- 更新按钮状态
function Lua_RunesCompoundCostCell:updateBtnState()
	self.select_mask:setEnable(self.data.isSelect);
end

function Lua_RunesCompoundCostCell:onPressClick()
	Lua_MsgUtil.callFunc("ON_SELECT_COST_ITEM", self.data);
	return true;
end

function Lua_RunesCompoundCostCell:onLongPressClick()
	DataCenter.packUtil:showItemInfo(self.rvo);
end