-- 符石合成 Panel
Lua_RunesCompoundPanel = class("Lua_RunesCompoundPanel", Lua_DisplayObject);

function Lua_RunesCompoundPanel:ctor(p)
	self:superCall("ctor", p, "RunesCompoundPanel_skin");
end

function Lua_RunesCompoundPanel:buildPanel()
	self:superCall("buildPanel");

	self:addLuaEvent("SRUNES_COMPOUND", self, self.showCompoundResult); -- 合成返回
        
    self:addLuaEvent("ON_SELECT_COMPOUND_ITEM", self, self.onCompoundCostWindow);
    self:addLuaEvent("UPDATE_COST_SELECT_INFO", self, self.updateCostSelectInfo);--材料选择返回数据

    self:addLuaEvent("MONEY_UPDATE", self, self.onItemUpdate);
end

function Lua_RunesCompoundPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.cost_obj:SetActive(false);
    self.showTips:setLangValue(126823);

    local vo = DataCenter.runesUtil.smelt_reward_vo;
    self.smelt_tips.text = LanUtil.formateStr(126824, tostring(DataCenter.runesUtil.smelt_value), vo.name);

    local pos = {{-151, 41}, {-241, 322}, {-1, 498}, {243, 322}, {146, 41}};
    self.showRunesArr = Array();
    local item;
    for i=1, 5 do
        item = Lua_RunesCompoundItem.new(self.content);
        item.index = i;
        item:setLocation(pos[i][1], pos[i][2]);
        self.showRunesArr:add(item);
    end

    self.help:addClickFuntion(self, self.onHelpClick);
    self.icon:addClickFuntion(self, self.onCheckCompound);--符石预览
    self.oneAdd_btn:addClickFuntion(self, self.onOneAddBtnClick);--一键添加
    self.skill_btn:addClickFuntion(self, self.onShowSkillBtnClick);  -- 技能展示
    self.compound_btn:addClickFuntion(self, self.onCompoundBtnClick);-- 合成

    self.sub:addClickFuntion(self, self.onSubBtnClick);--减
    self.add:addClickFuntion(self, self.onAddBtnClick);--加
    self.smeltBtn:addClickFuntion(self, self.onSmeltBtnClick);--熔炼奖励

    self.showPutNum = DataCenter.runesData.showPutNum;
    self:updatePutNum(self.showPutNum);
    self:showCompoundInfo();

    Lua_WindowUtil.openWin("Lua_RunesTipsWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_RunesCompoundPanel:dispose()
	 if self.showRunesArr ~= nil then
        self.showRunesArr:dispose();
        self.showRunesArr:clear();
        self.showRunesArr = nil;
    end

    if self.redPoint ~= nil then
        self.redPoint:dispose();
        self.redPoint = nil;
    end

    if self.showEff ~= nil then
        self.showEff:dispose();
        self.showEff = nil;
    end
    Lua_CommonUtil.removeTimer(self, self.showEndCompoundEff);
    Lua_CommonUtil.removeTimer(self, self.sendCompoundRunes);
    self.selectRunesUidDic = nil;
	self:superCall("dispose")
end

function Lua_RunesCompoundPanel:showCompoundInfo()
    self.selectRunesUidDic = {};
    local id = DataCenter.runesUtil.smelt_id;
    local num = DataCenter.packData:getItemCountById(id);
    local maxNum = DataCenter.runesUtil.smelt_value;
    self.smelt_num.text = num;
    
    self.smeltBar:setMaxValue(maxNum);
    self.smeltBar:setValue(num);
    -- self.smeltBar:setText(num.."/"..maxNum);
    if num >= maxNum then
        if self.redPoint == nil then
            self.redPoint = Lua_RedPointIcon.new(self.content);
            self.redPoint:setRectAnchor(7);
            self.redPoint:setLocation(-215, 416, 0);
            self.redPoint:createRedPointEff();
        end
        self.redPoint:updateRedPointShow(true);        
    else
        if self.redPoint ~= nil then
            self.redPoint:updateRedPointShow(false);
        end
    end
    
    self:updateShowCompound(self.selectRunesUidDic);
end

--材料选择更新合成展示
function Lua_RunesCompoundPanel:updateShowCompound(list)
    self.selectRunesUidDic = list;
    local uid;
    self.select_num = 0;
    local index = 0;
    local _lits = {};
    for k,v in pairs(list) do
        index = index+1;
        _lits[index] = k;
        uid = k;
        self.select_num = self.select_num + 1;
    end

    for i=1, self.showRunesArr:getSize() do
        self.showRunesArr[i]:setData(_lits[i]);
    end

    if uid ~= nil then
        local r_vo = DataCenter.runesData:getRunesVoByUid(uid);
        self.compoundVo = Lua_RunesVo.new(r_vo.next_item_id);
        self.icon:setEnable(true);
        self.icon_bg:setEnable(true);
        self.icon:setAltas(self.compoundVo.atlas, self.compoundVo.sprite);
        self.icon_bg:setAltas("rune_atlas", "xui_fs_bg_0"..11-self.compoundVo.color);

        if index < DataCenter.runesUtil.put_runes_min then
            self.cost_obj:SetActive(false);
            self.succeed_tips:setLangValue(126822);
        else
            self.cost_obj:SetActive(true);

            local succeed = DataCenter.runesData:getSucceedNum(r_vo.compose_rate,index);
            local color;
            if succeed <= 0.4 then
                color = "ed4b2e";
            elseif succeed > 0.4 and succeed < 0.8  then
                color = "f8ef89";
            else
                color = "8Bf66b";
            end
            self.succeed_tips.text = LanUtil.formateStr(126828, "<color=#"..color..">"..(succeed*100).."</color>");

            self.show_num = r_vo.compose_consume[1][2] * index;
            self.cost_id = r_vo.compose_consume[1][1];
            local tvo = Lua_ToolVo.new(self.cost_id);
            self.cost_icon:setAltas(tvo.atlas, tvo.sprite);
            self.cost_value.text = numberTrans(self.show_num);
        end
    else
        self.compoundVo = nil;
        self.icon:setEnable(false);
        self.icon_bg:setEnable(false);
        self.cost_obj:SetActive(false);
        self.succeed_tips:setLangValue(126822);
    end
end

function Lua_RunesCompoundPanel:onCheckCompound()
    if self.compoundVo == nil then
        return;
    end
    Lua_WindowUtil.openWin("Lua_RunesRecastSkillDesWindow", Lua_WinParam.ACTION_OPEN, self.compoundVo);
end

--选择材料返回
function Lua_RunesCompoundPanel:updateCostSelectInfo(list)
    self.selectRunesUidDic = list;
    self:updateShowCompound(list);
end

--打开材料选择界面
function Lua_RunesCompoundPanel:onCompoundCostWindow()
    Lua_WindowUtil.openWin("Lua_RunesCompoundCostWindow", Lua_WinParam.ACTION_OPEN, self.selectRunesUidDic);
end

--一键选择数量
function Lua_RunesCompoundPanel:updatePutNum(val)
    DataCenter.runesData.showPutNum = val;
    self.sub:setGray(val <= DataCenter.runesUtil.put_runes_min);
    self.add:setGray(val >= DataCenter.runesUtil.put_runes_max);
    self.num.text = val;
end

function Lua_RunesCompoundPanel:onSubBtnClick()
    self.showPutNum = self.showPutNum -1;
    if self.showPutNum < DataCenter.runesUtil.put_runes_min then
        self.showPutNum = DataCenter.runesUtil.put_runes_min;
    end
    
    self:updatePutNum(self.showPutNum);
end

function Lua_RunesCompoundPanel:onAddBtnClick()
    self.showPutNum = self.showPutNum +1;
    if self.showPutNum > DataCenter.runesUtil.put_runes_max then
        self.showPutNum = DataCenter.runesUtil.put_runes_max;
    end
    self:updatePutNum(self.showPutNum)
end

function Lua_RunesCompoundPanel:onHelpClick()
    local param = { des = LanUtil.getValue(126845), posX = 175, posY = -300 };
    Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_RunesCompoundPanel:onShowSkillBtnClick()
    Lua_WindowUtil.openWin("Lua_RunesSkillShowWindow", Lua_WinParam.ACTION_OPEN, 1);
end

function Lua_RunesCompoundPanel:onSmeltBtnClick()
    if self.bShowEffect then
        OperateAlert.showLangValue(126856);
        return;
    end

    Lua_WindowUtil.openWin("Lua_RunesSmeltRewardWindow", Lua_WinParam.ACTION_OPEN);
end

--一键添加
function Lua_RunesCompoundPanel:onOneAddBtnClick()
    if self.bShowEffect then
        OperateAlert.showLangValue(126856);
        return
    end

    self.selectRunesUidDic,isBool = DataCenter.runesData:getOneSelectCostDic(self.showPutNum);
    --print(self.showPutNum,"= = 一键添加 = =",isBool)
    if isBool == false then
        OperateAlert.showLangValue(126825);
        Lua_WindowUtil.openWin("Lua_RunesCompoundCostWindow", Lua_WinParam.ACTION_OPEN, self.selectRunesUidDic);
    end
    self:updateShowCompound(self.selectRunesUidDic);
end

--合成
function Lua_RunesCompoundPanel:onCompoundBtnClick()
    if self.bShowEffect then
        OperateAlert.showLangValue(126856);
        return
    end

    local select_num = 0;
    for k,v in pairs(self.selectRunesUidDic) do
        if v == 1 then
            select_num = select_num +1;
        end
    end
    if select_num == 0 then
        OperateAlert.showLangValue(126820);
        return
    end
    if select_num < DataCenter.runesUtil.put_runes_min then
        OperateAlert.showLangValue(126821);
        return
    end

    local pack_num = DataCenter.packData:getItemCountById(self.cost_id);
    if pack_num < self.show_num then--钱不够
        DataCenter.packUtil:openPathWindow(self.cost_id , false);
        return;
    end

    self:showCompoundEffect();
end

function Lua_RunesCompoundPanel:showCompoundEffect()
    self.bShowEffect = true;
    self:showCompoundItemEff();
    Lua_CommonUtil.delayCall(1, self, self.showEndCompoundEff);
end

function Lua_RunesCompoundPanel:showCompoundItemEff()
    local eff_pos = {{152,-40},{240,-322},{0,-500},{-242,-323},{-150,-40}}
    for i=1, self.showRunesArr:getSize() do
        self.showRunesArr[i].bShowEffect = true;

        if i <= self.select_num then
            self.showRunesArr[i]:showItemEff(true, i, eff_pos[i]);
        end
    end
end

function Lua_RunesCompoundPanel:showEndCompoundEff()
    if self.showEff == nil then
        self.showEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_zb_fshc_06", "ui_zb_fshc_06", 0, 0);
    else
        self.showEff:setEnable(false);
        self.showEff:setEnable(true); 
    end
    Lua_CommonUtil.delayCall(0.5, self, self.sendCompoundRunes);
end

function Lua_RunesCompoundPanel:sendCompoundRunes()
    Lua_ProxyManager.getProxy("Lua_RunesProxy"):sCompoundRunes(self.selectRunesUidDic);
end

function Lua_RunesCompoundPanel:showCompoundResult()
    self.bShowEffect = false;
    for i=1, self.showRunesArr:getSize() do
        self.showRunesArr[i].bShowEffect = nil;
    end
    self:showCompoundInfo();
end

function Lua_RunesCompoundPanel:onItemUpdate(dic)
    if self.cost_id == nil or self.selectRunesUidDic == nil or dic == nil or dic[self.cost_id] == nil then
        return;
    end
    self:updateShowCompound(self.selectRunesUidDic);
end






























Lua_RunesCompoundItem = class("Lua_RunesCompoundItem", Lua_DisplayObject);
function Lua_RunesCompoundItem:ctor(p)
    self:superCall("ctor", p, "RunesCompoundItem_skin");
end

function Lua_RunesCompoundItem:buildShowItem()
    self:superCall("buildShowItem");

    -- self.bg:addClickFuntion(self, self.onBtnClick);
    self.bg:addMousDownFuntion(self, self.onMouseDownFun);
    self.bg:addMouseUpFuntion(self, self.onMouseUpFun);
end

function Lua_RunesCompoundItem:setData(uid)
    if uid == nil then
        self.data = nil;
        self.add:setEnable(true);
        self.icon:setEnable(false);
        self.show:setEnable(false);
    else
        self.add:setEnable(false);
        self.icon:setEnable(true);
        self.show:setEnable(true);
        self.data = DataCenter.runesData:getRunesVoByUid(uid);
        self.icon:setAltas(self.data.atlas, self.data.sprite);
    end
end

function Lua_RunesCompoundItem.Set:bShowEffect(bool)
    self._bShowEffect = bool
end

function Lua_RunesCompoundItem:onBtnClick()
    if self._bShowEffect then
        OperateAlert.showLangValue(126856);
        return
    end
    -- if self.data == nil then
        Lua_MsgUtil.callFunc("ON_SELECT_COMPOUND_ITEM");
    -- else
    --     DataCenter.packUtil:showItemInfo(self.data);
    -- end
end

function Lua_RunesCompoundItem:onMouseDownFun()
    self.startClickTime = getTime();
    self.onPress = true;
    self:addTimer("Lua_RunesCompoundItem_onLongPressFun", 0.3, self, self.onLongPressFun, nil, 1);
end

function Lua_RunesCompoundItem:onMouseUpFun()
    if self.onPress == false then
        return;
    end
    self:removeTimer(self, self.onLongPressFun);

    if self._bShowEffect then
        OperateAlert.showLangValue(126856);
        return;
    end

    if self.data == nil or getTime() - self.startClickTime <= 0.3 then
        Lua_MsgUtil.callFunc("ON_SELECT_COMPOUND_ITEM");
    else
        self:onLongPressFun();
    end
end

function Lua_RunesCompoundItem:onLongPressFun()
    self.onPress = false;
    self:removeTimer(self, self.onLongPressFun);

    if self._bShowEffect then
        OperateAlert.showLangValue(126856);
        return;
    end
    DataCenter.packUtil:showItemInfo(self.data);
end

function Lua_RunesCompoundItem:showItemEff(bool, index, pos)
    if bool == true then
        if self.tag_select_num ~= index then
            self.tag_select_num = index;
            if self.showEff == nil then
                self.showEff = UICreate.createUIEffect(self.content, nil, nil, 0, 0);
            end
            self.showEff:setLocation(pos[1],pos[2],0);
            self.showEff:setUrl("/effects/uiEffects/ui_zb_fshc_0"..index,"ui_zb_fshc_0"..index);
        else
            if self.showEff ~= nil then
                self.showEff:setEnable(false);
                self.showEff:setEnable(true);
            end
        end
    else
        if self.showEff ~= nil then
            self.showEff:setEnable(false);
        end
    end
end

function Lua_RunesCompoundItem:dispose()
    self.data = nil;
    if self.showEff ~= nil then
        self.showEff:dispose();
        self.showEff = nil;
    end
    self:superCall("dispose");
end
