-- 符石合成
checkRequire("Lua_RunesCompoundPanel");
checkRequire("Lua_CharmCompoundPanel");
Lua_RunesCompoundWindow = class("Lua_RunesCompoundWindow", Lua_Window);
function Lua_RunesCompoundWindow:ctor()
    self:superCall("ctor");

    self.isFullSizeWin = true;
    self.showBackBtn = true;
    self.windowName = "Lua_RunesCompoundWindow";
    self.skinName = "RunesCompoundWindow_skin";

    for i = 1, 6 do
        self:addPreLoadRes("/effects/uiEffects/ui_zb_fshc_0" .. i, Lua_LoadFileType.UNITY3D);
    end
end

function Lua_RunesCompoundWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.backBtn:setLocation(77, 54, 0);

    self.showBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_widget_005", 0, 60.5, 720, 121);
    self.showBg.anchor = Lua_WindowUtil.getAnchor(7);
    self.showBg.siblingIndex = 1;

    self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content);
    self.roleInfoPanel:setRectAnchor(1);
    self.roleInfoPanel:setAvatarClickOpenWin("Lua_TopLayerPersonalInfoWindow");

    local tabInfoArr = Array();
    tabInfoArr:add({panel = Lua_RunesCompoundPanel, textAtlas = "hero_tactic_atlas", textNormalSprite = "xui_zf_zgnbutton_1_n", textSelectedSprite = "xui_zf_zgnbutton_1_p"});
    tabInfoArr:add({panel = Lua_CharmCompoundPanel, textAtlas = "hero_tactic_atlas", textNormalSprite = "xui_zf_zgnbutton_2_n", textSelectedSprite = "xui_zf_zgnbutton_2_p"});

    self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.btnList.pivot = -1;
    self.btnList:setRectAnchor(7);
    self.btnList:setLocation(240, 53, 0);
    self.btnList:setButtonStyle("common_altas_1", "ui_common_button_001_b", "ui_common_button_001_b", 118, 108, 0.01, 1);
    self.btnList:setButtonLine("common_altas_1", "xui_common_line_001", 2, 115, 0, 0, 1);
    self.btnList:setButtonItem(120, 108);
    self.btnList:setClickCallBack(self, self.onBtnClick);
    self.btnList:setData(tabInfoArr);
end

function Lua_RunesCompoundWindow:dispose()
    if self.showBg ~= nil then
        self.showBg:dispose();
        self.showBg = nil;
    end
    if self.roleInfoPanel ~= nil then
        self.roleInfoPanel:dispose();
        self.roleInfoPanel = nil;
    end
    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end
    self:superCall("dispose");
end


function Lua_RunesCompoundWindow:showWin(param)
    local index = param;
    if index == nil then
        index = 1;
    end
    
    self.btnList:setSelected(index);
end

function Lua_RunesCompoundWindow:onBtnClick(index, data)
    self.index = index;

    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end

    local showPanel = data.panel;
    self.curPanel = showPanel.new(self.content);
    self.curPanel:setRectAnchor(9)
end
