--符文重铸
Lua_RunesLuckyRecastWindow = class("Lua_RunesLuckyRecastWindow", Lua_Window);
function Lua_RunesLuckyRecastWindow:ctor()
    self:superCall("ctor");
    self.showBlackMask = true;
    self.isClickClose = true;
    self.windowName = "Lua_RunesLuckyRecastWindow";
    self.skinName = "RunesLuckyRecastWindow_skin";
end

function Lua_RunesLuckyRecastWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.tag_count = 0;
    self.showDes.text = LanUtil.formateStr(126841, tostring(DataCenter.runesUtil.lucky_recast_num));
    
    self.showRecastArr = Array();
	local item;
	for i = 1, DataCenter.runesUtil.lucky_recast_num do
		item = Lua_RunesLuckyRecastItem.new(self.content);
		item:setLocation(-203 + (i - 1) * 203, 184, 0);
		item:setData(nil);
		self.showRecastArr:add(item);
	end
 	
 	self.dragList = Lua_DragList.new(self.content, 610, 430, Lua_AxisDefine.Vertical);
    self.dragList:setLocation(0, -167);
    self.dragList.canLongPress = true;
    self.dragList.longPressLimit = 0.4;
    self.dragList:setListCell(Lua_RunesLuckyRecastSkillItem, 138, 160, 4);
    self.dragList:setCellSpacing(20, 20);

    self.sureBtn:addClickFuntion(self, self.onSubBtnClick);

    self:addLuaEvent("ON_LUCKY_RECAST_ITEM", self, self.selectLuckyItem);--点击重铸技能item
    self:addLuaEvent("ON_LUCKY_RECAST_CELL", self, self.selectLuckyCell);--点击重铸技能列表Cell
    self:addLuaEvent("UPDATE_LUCKY_RECAST", self, self.updateLuckyRecastInfo);
end

function Lua_RunesLuckyRecastWindow:showWin(param)
    self:superCall("showWin",param);
    Lua_ProxyManager.getProxy("Lua_RunesProxy"):sLuckyRecast(param.color);
end

--列表更新
function Lua_RunesLuckyRecastWindow:updateLuckyRecastInfo(msg)
    self.dragList:setArrayData(msg);
end

--点击重铸技能item
function Lua_RunesLuckyRecastWindow:selectLuckyItem(skillId)
    self:removeSkillId(skillId);
    self:updateDragList();
end

--点击重铸技能列表Cell
function Lua_RunesLuckyRecastWindow:selectLuckyCell(skillVo)
    local skillId = skillVo.skillId;
    if self.selectSkillDic == nil then
        self.selectSkillDic = {};
    end

    if self.selectSkillDic[skillId] == nil and self.tag_count == DataCenter.runesUtil.lucky_recast_num then
        local str = LanUtil.formateStr(126842,DataCenter.runesUtil.lucky_recast_num);
        OperateAlert.show(str);
        return;
    end

    if self.selectSkillDic[skillId] == nil then
        self.selectSkillDic[skillId] = 1;
        self.tag_count = self.tag_count + 1;
        self:updateShowSkill(skillVo);
    else
        self:removeSkillId(skillId)
        self:removeShowSkill(skillVo);
    end

    self.dragList.customParam = self.selectSkillDic;
    self:updateShowSkill();
    self:updateDragList();
end

--移除展示的技能
function Lua_RunesLuckyRecastWindow:removeSkillId(skillId)
    self.selectSkillDic[skillId] = nil;
    self.tag_count = self.tag_count - 1;
end

--更新选中的技能展示
function Lua_RunesLuckyRecastWindow:updateShowSkill(skillVo)
    local len = self.showRecastArr:getSize();
    for i=1,len do
        if self.showRecastArr[i].data == nil then
            self.showRecastArr[i]:setData(skillVo);
            break;
        end
    end
end

--移除选中的技能展示
function Lua_RunesLuckyRecastWindow:removeShowSkill(skillVo)
    local len = self.showRecastArr:getSize();
    for i=1,len do
        if self.showRecastArr[i].data ~= nil and self.showRecastArr[i].data.skillId == skillVo.skillId  then
            self.showRecastArr[i]:setData(nil);
            break;
        end
    end
end

--更新技能列表
function Lua_RunesLuckyRecastWindow:updateDragList(skill_id)
    if self.dragList ~= nil then
        local arr = self.dragList.showList;
        local len = arr:getSize();
        for i = 1, len do
            arr[i]:updateSelect(self.selectSkillDic[arr[i].skill_vo.skillId] == 1);
        end
    end
end

--确认选择
function Lua_RunesLuckyRecastWindow:onSubBtnClick()
    if self.tag_count < DataCenter.runesUtil.lucky_recast_num then
        local str = LanUtil.formateStr(126843, DataCenter.runesUtil.lucky_recast_num);
        OperateAlert.show(str);
        return;
    end
    Lua_ProxyManager.getProxy("Lua_RunesProxy"):sRecastRunes(self.showData.unique_id, 1, self.showData.hero_uid, self.selectSkillDic);
    self:hide();
end

function Lua_RunesLuckyRecastWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    if self.showRecastArr ~= nil then
        self.showRecastArr:dispose();
        self.showRecastArr:clear();
        self.showRecastArr = nil;
    end
    self.selectSkillDic = nil;
    self:superCall("dispose");
end





















Lua_RunesLuckyRecastItem = class("Lua_RunesLuckyRecastItem", Lua_DisplayObject); 
function Lua_RunesLuckyRecastItem:ctor(p) 
    self:superCall("ctor", p, "RunesLuckyRecastItem_skin");
end

function Lua_RunesLuckyRecastItem:buildShowItem()
    self:superCall("buildShowItem");
    self.bg:addClickFuntion(self, self.onClick);
end

function Lua_RunesLuckyRecastItem:dispose()
    if self.skill_icon ~= nil then
        self.skill_icon:dispose();
        self.skill_icon = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end

function Lua_RunesLuckyRecastItem:setData(data)
    self.data = data;
    if data == nil then
        if self.skill_icon ~= nil then
            self.skill_icon:setEnable(false);
        end
    	self.nameText:setEnable(false);
    else
    	if self.skill_icon == nil then
            self.skill_icon = Lua_SkillIconItem.new(self.content);
            self.skill_icon:setCanClick(false);
        end
        self.skill_icon:setEnable(true);
        self.skill_icon:setData(data);
        self.skill_icon:setRarityIcon(data.rarity);

        self.nameText:setEnable(true);
    	self.nameText.text = data.name;
    end
end

function Lua_RunesLuckyRecastItem:onClick(go)
    if self.data == nil then
        return
    end
    Lua_MsgUtil.callFunc("ON_LUCKY_RECAST_ITEM", self.data.skillId);
    self:setData(nil);
end





















Lua_RunesLuckyRecastSkillItem = class("Lua_RunesLuckyRecastSkillItem", Lua_ListCell);
function Lua_RunesLuckyRecastSkillItem:ctor(p)
    self:superCall("ctor", p, "RunesLuckyRecastSkillItem_skin");
end

function Lua_RunesLuckyRecastSkillItem:buildShowItem()
    self:superCall("buildShowItem");
    self.skill_icon = Lua_SkillIconItem.new(self.content);
    self.skill_icon:setLocation(0,19,0);
    self.skill_icon:setSiblingIndex(0);
    self.skill_icon:setCanClick(false);
    
    self.select_mask:setEnable(false);
    self.select_label:setEnable(false);
end

function Lua_RunesLuckyRecastSkillItem:dispose()
    if self.skill_icon ~= nil then
        self.skill_icon:dispose();
        self.skill_icon = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end

function Lua_RunesLuckyRecastSkillItem:setData(id)
    if id == nil then
        return
    end

    self.skill_vo = Lua_SkillConfigData.getConfigData(id);
    self.skill_icon:setData(self.skill_vo);
    self.skill_icon:setRarityIcon(self.skill_vo.rarity);
    self.skill_name.text = self.skill_vo.name;

    if self.customParam ~= nil then
        local bool = self.customParam[self.skill_vo.skillId] == 1;
        self:updateSelect(bool);
    end
end

function Lua_RunesLuckyRecastSkillItem:setCustomParam(customParam)
    self.customParam = customParam;
end

function Lua_RunesLuckyRecastSkillItem:onPressClick()
	if self.skill_vo == nil then
		return;
	end
	Lua_MsgUtil.callFunc("ON_LUCKY_RECAST_CELL", self.skill_vo);
end

function Lua_RunesLuckyRecastSkillItem:updateSelect(bSelect)
    self.select_mask:setEnable(bSelect);
    self.select_label:setEnable(bSelect);
end

function Lua_RunesLuckyRecastSkillItem:onLongPressClick()
    if self.skill_vo == nil then
        return;
    end
    Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.skill_vo);
end