-- 战法养成 Window
checkRequire("Lua_TacticDevelopBasePanel");
checkRequire("Lua_TacticAttributeItem");
checkRequire("Lua_TacticAttrCompareItem");
checkRequire("Lua_TacticSkillIconItem");
Lua_TacticDevelopWindow = class("Lua_TacticDevelopWindow", Lua_Window);

function Lua_TacticDevelopWindow:ctor()
    self:superCall("ctor");

    self.isFullPaving = true;
    self.isFullSizeWin = true;
    self.showBackBtn = true;
    self.showWinBg = true;
    self.winBgPath = "/images/hero_tactic/xui_zf_bg_1.jpg";

    self.windowName = "Lua_TacticDevelopWindow";
    self.skinName = "TacticDevelopWindow_skin";

    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
    self:addPreLoadRes("/images/hero_tactic/xui_zf_bg_2.jpg", Lua_LoadFileType.IMG);
    self:addPreLoadRes("/images/hero_tactic/xui_zf_widget_4.png", Lua_LoadFileType.IMG);
end

function Lua_TacticDevelopWindow:buildPanel(go)
    self:superCall("buildPanel", go);
end

function Lua_TacticDevelopWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content);
    self.roleInfoPanel:setRectAnchor(1);

    self.btnInfoArr = Array();
    self.btnInfoArr:add({textAtlas = "hero_tactic_atlas", textNormalSprite = "xui_zf_zgnbutton_1_n", textSelectedSprite = "xui_zf_zgnbutton_1_p", panelStr = "Lua_TacticIntensifyPanel", bgPath = "/images/hero_tactic/xui_zf_bg_1.jpg", redPointId = Lua_RedPointList.TacticUpgrade});
    self.btnInfoArr:add({textAtlas = "hero_tactic_atlas", textNormalSprite = "xui_zf_zgnbutton_2_n", textSelectedSprite = "xui_zf_zgnbutton_2_p", panelStr = "Lua_TacticUpStarPanel", bgPath = "/images/hero_tactic/xui_zf_bg_1.jpg", redPointId = Lua_RedPointList.TacticUpstar});
    self.btnInfoArr:add({textAtlas = "hero_tactic_atlas", textNormalSprite = "xui_zf_zgnbutton_3_n", textSelectedSprite = "xui_zf_zgnbutton_3_p", panelStr = "Lua_TacticConnectPanel", bgPath = "/images/hero_tactic/xui_zf_bg_1.jpg"});
    self.btnInfoArr:add({textAtlas = "hero_tactic_atlas", textNormalSprite = "xui_zf_zgnbutton_4_n", textSelectedSprite = "xui_zf_zgnbutton_4_p", panelStr = "Lua_TacticFetterPanel", bgPath = "/images/hero_tactic/xui_zf_bg_2.jpg", redPointId = Lua_RedPointList.TacticFetter});

    self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.btnList.pivot = -1;
    self.btnList:setRectAnchor(7);
    self.btnList:setLocation(122, 53, 0);
    self.btnList:setButtonStyle("common_altas_1", "ui_common_button_001_b", "ui_common_button_001_b", 118, 108, 0.01, 1);
    self.btnList:setButtonLine("common_altas_1", "xui_common_line_001", 2, 115, 0, 0, 1);
    self.btnList:setButtonItem(120, 108);
    self.btnList:setRedPoint(40, 40);
    self.btnList:setClickCallBack(self, self.onBtnClick)
    self.btnList:setData(self.btnInfoArr);
end

function Lua_TacticDevelopWindow:showWin(param)
    self:superCall("showWin", param);

    self.tacticId = param.tacticId;

    local index = param.index;
    if index == nil then
        index = 1;
    end
    if self.idx ~= nil and self.idx == index then
        if self.curPanel ~= nil and self.curPanel.setData ~= nil then
            self.curPanel:setData(self.tacticId);
        end
    else
        self.btnList:setSelected(index);
    end

    self:checkBtnRedDot();
end

function Lua_TacticDevelopWindow:dispose()
    if self.roleInfoPanel ~= nil then
        self.roleInfoPanel:dispose();
        self.roleInfoPanel = nil;
    end
    if self.btnList ~= nil then
        self.btnList:dispose();
        self.btnList = nil;
    end
    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end
    self:superCall("dispose");
end

function Lua_TacticDevelopWindow:onBtnClick(idx, data)
    if self.idx ~= nil and self.idx == idx then return end
    self.idx = idx;

    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end
    if data.panelStr ~= nil then
        local showPanel = checkRequire(data.panelStr);
        self.curPanel = showPanel.new(self.content);
        self.curPanel:setRectAnchor(9);
        if self.curPanel.setData ~= nil then
            self.curPanel:setData(self.tacticId);
        end
        
        if self.winBg.url ~= data.bgPath then
            self.winBg.url = data.bgPath;
        end
    end
end

function Lua_TacticDevelopWindow:checkBtnRedDot()
    local tacticVo = DataCenter.packData:getItemVoById(self.tacticId);
    DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TacticUpgrade, tacticVo.isUpgrade);
    DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TacticUpstar, tacticVo.isUpstar);
    DataCenter.redPointData:updateRedPointState(Lua_RedPointList.TacticFetter, DataCenter.heroTacticData.getFetterRedState);
end