-- 战法图鉴属性 Window
Lua_TacticFetterPropWindow = class("Lua_TacticFetterPropWindow", Lua_Window);

function Lua_TacticFetterPropWindow:ctor()
    self:superCall("ctor");

    self.showBlackMask = true;
    self.isClickClose = true;

    self.windowName = "Lua_TacticFetterPropWindow";
    self.skinName = "TacticFetterPropWindow_skin";
end

function Lua_TacticFetterPropWindow:buildPanel(go)
    self:superCall("buildPanel", go);
end

function Lua_TacticFetterPropWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.propArr = Array();
end

function Lua_TacticFetterPropWindow:showWin(param)
    self:superCall("showWin", param);

    local num = param:getSize();
    local len = self.propArr:getSize();
    local count = len > num and len or num;
    for i = 1, count do
        item = self.propArr[i];
        if item == nil then
            item = Lua_TacticFetterPropItem.new(self.content);
            item:setLocation(-150 + (i - 1) % 2 * 300, 25 - Mathf.Floor((i - 1) / 2) * 45, 0);
            self.propArr:add(item);
        end

        if num >= i then
            item:setData(param[i]);
        end
        item:setEnable(num >= i);
    end

    local height = Mathf.Floor((num + 1) / 2) * 45;
    self.winBg:SetDimensions(684, 200 + height);
end

function Lua_TacticFetterPropWindow:dispose()
    if self.propArr ~= nil then
        self.propArr:dispose();
        self.propArr = nil;
    end
    self:superCall("dispose");
end




























Lua_TacticFetterPropItem = class("Lua_TacticFetterPropItem", Lua_DisplayObject);

function Lua_TacticFetterPropItem:ctor(p)
    self:superCall("ctor", p, "TacticFetterPropItem_skin");
end

function Lua_TacticFetterPropItem:buildShowItem()
    self:superCall("buildShowItem");

    self.attrItem = Lua_TacticAttributeItem.new(self.content, 4);
    self.attrItem:setLocation(-110, 0, 0);
end

function Lua_TacticFetterPropItem:setData(attrVo)
    self.attrItem:setData(attrVo);
end

function Lua_TacticFetterPropItem:dispose()
    if self.attrItem ~= nil then
        self.attrItem:dispose();
        self.attrItem = nil;
    end
    self:superCall("dispose");
end

