-- 战法图鉴升级 Window
Lua_TacticFetterUpWindow = class("Lua_TacticFetterUpWindow", Lua_Window);

function Lua_TacticFetterUpWindow:ctor()
	self:superCall("ctor");

    self.showBlackMask = true;
    self.isClickClose = true;

	self.windowName = "Lua_TacticFetterUpWindow";
	self.skinName = "TacticFetterUpWindow_skin";
end

function Lua_TacticFetterUpWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.attrItemArr = Array();

	self:showEffect();
end

function Lua_TacticFetterUpWindow:dispose()
	if self.attrItemArr ~= nil then
		self.attrItemArr:dispose();
		self.attrItemArr = nil;
	end
	if self.diBgEffect then
		self.diBgEffect:dispose();
		self.diBgEffect = nil;
	end
	if self.fontEffect then
		self.fontEffect:dispose();
		self.fontEffect = nil;
	end
	if self.flyEffect then
		self.flyEffect:dispose();
		self.flyEffect = nil;
	end
	self:superCall("dispose");
end

function Lua_TacticFetterUpWindow:showWin(param)
	self:superCall("showWin", param);
	
	local fetterVo = DataCenter.heroTacticData:getFetterVo(param);
	local arr;
	if fetterVo.starLv <= 0 then
		self.titleSp:setAltas("common_altas_5", "xui_cbg_title_9");
		arr = DataCenter.heroTacticUtil:fetterPropVoArr(fetterVo.starLvId);
	else
		self.titleSp:setAltas("common_altas_5", "xui_ys_title_5");
		arr = DataCenter.heroTacticUtil:fetterUpPropVoArr(fetterVo.starLvId - 1);
	end
	self.titleSp:resetSize();

    local len = arr:getSize();
    local num = self.attrItemArr:getSize();
    local count = len > num and len or num;
    local item;
    for i = 1, count do
        item = self.attrItemArr[i];
        if item == nil then
            item = Lua_TacticFetterUpItem.new(self.content);
            self.attrItemArr:add(item);
        end

        if len >= i then
            item:setData(arr[i]);
            item:setCellSeqIndex(i);
            item:setLocation(0, (i - 1) * 50 - (len - 1) / 2 * 50, 0);
        end
        item:setEnable(len >= i);
    end
end

function Lua_TacticFetterUpWindow:showEffect()
	if self.diBgEffect == nil then
		self.diBgEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_shengduan_di", "ui_shengduan_di", 0, 0)
		self.diBgEffect.siblingIndex = 4;
	end
	if self.fontEffect == nil then
		self.fontEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_shengduan_ziti", "ui_shengduan_ziti", 0, 0)
		self.fontEffect.siblingIndex = 4;
	end
	if self.flyEffect == nil then
		self.flyEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_shengduan_piao", "ui_shengduan_piao", 0, 0)
		self.flyEffect.siblingIndex = 4;
	end
end
























Lua_TacticFetterUpItem = class("Lua_TacticFetterUpItem", Lua_ListCell);

function Lua_TacticFetterUpItem:ctor(p)
	self:superCall("ctor", p, "TacticFetterUpItem_skin");
end

function Lua_TacticFetterUpItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_TacticFetterUpItem:dispose()
	self:superCall("dispose");
end

function Lua_TacticFetterUpItem:setData(attrVo)
    self.nameTxt.text = attrVo.show_name;

    if attrVo.nextValue > 0 then
    	self.lastTxt.text = attrVo.showValue;
    	self.curTxt.text = attrVo.showNextValue;
    else
    	self.lastTxt.text = "0";
    	self.curTxt.text = attrVo.showValue;
    end
end

function Lua_TacticFetterUpItem:setCellSeqIndex(idx)
    self:superCall("setCellSeqIndex", idx);
    self.attrBg:setEnable(idx % 2 == 0);
end











