-- 战法重置 Window
Lua_TacticResetWindow = class("Lua_TacticResetWindow", Lua_Window);

function Lua_TacticResetWindow:ctor()
    self:superCall("ctor");

    self.showBlackMask = true;
    self.isClickClose = true;

    self.windowName = "Lua_TacticResetWindow";
    self.skinName = "TacticResetWindow_skin";
end

function Lua_TacticResetWindow:buildPanel(go)
    self:superCall("buildPanel", go);
end

function Lua_TacticResetWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setLocation(-105, 115, 0);

    self.itemList = Lua_ItemIconList.new(self.content);
    self.itemList.canClick = true;
    self.itemList.scaleVal = 0.8;
    self.itemList:setLocation(0, -130, 0);

    self.cancelBtn:addClickFuntion(self, self.hide);
    self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_TacticResetWindow:showWin(param)
    self:superCall("showWin", param);

    self.itemIcon:setData(param);
    self.itemIcon:showNum(0);
    self.itemIcon:setTacticWear(nil, nil);

    self.nameTxt.text = param.tacticName;
    self.lvlTxt.text = LanUtil.formateStr(792018, param.tacticLevel);

    local costInfo = DataCenter.heroTacticUtil.rebirth_cost;
    local ratioVal = DataCenter.heroTacticUtil.rebirth_lose;
    self.costId = costInfo[1];
    self.costNum = costInfo[2]; --costInfo[2] * (param.tacticLevel - param.min_level);
    self.showTxt.text = LanUtil.formateStr(792019, spliceIconStrById(costInfo[1]), numberTrans(self.costNum), ratioVal * 100);
    
    local packNum = numberTrans(DataCenter.packData:getItemCountById(costInfo[1]));
    self.costTxt.text = LanUtil.formateStr(792003, packNum, self.costNum);
    self.costTxt:resetSize();

    local addWidth = self.costTxt.width - 140;
    if addWidth < 0 then
        addWidth = 0;
    end
    self.costBg:SetDimensions(167 + addWidth, 32);

    local dic = DataCenter.heroTacticUtil:totalUpgradeCostDic(param);
    local arr = Array();
    local vo;
    for k, v in pairs(dic) do
        vo = Lua_ToolVo.createToolVo(k, Mathf.Floor(v * ratioVal));
        arr:add(vo);
    end
    self.itemList:setArrayData(arr);
end

function Lua_TacticResetWindow:dispose()
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    if self.itemList ~= nil then
        self.itemList:dispose();
        self.itemList = nil;
    end
    self:superCall("dispose");
end

function Lua_TacticResetWindow:onBuyBtnClick()
    if DataCenter.moneyData:isMoneyEnough(self.costId, self.costNum, true) then
        Lua_ProxyManager.getProxy("Lua_HeroTacticProxy"):sTacticReset(self.showData.unique_id);
        self:hide();
    end
end
