-- 战法选择 Window
Lua_TacticSelectWindow = class("Lua_TacticSelectWindow", Lua_Window);

function Lua_TacticSelectWindow:ctor()
    self:superCall("ctor");

    self.showBlackMask = true;
    self.isClickClose = true;

    self.windowName = "Lua_TacticSelectWindow";
    self.skinName = "TacticSelectWindow_skin";
end

function Lua_TacticSelectWindow:buildPanel(go)
    self:superCall("buildPanel", go);
    self:addLuaEvent("UPDATE_HERO_TACTIC_INFO", self, self.checkCloseWin);
    self:addLuaEvent("UPDATE_TACTIC_INFO", self, self.updateData);

    self:addLuaEvent("ON_TACTIC_SELECT_CLICK", self, self.onItemClick);
end

function Lua_TacticSelectWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.dragList = Lua_DragList.new(self.content, 610, 730, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_TacticSelectItem, 130, 160, 4);
    self.dragList:setCellSpacing(30, 20);
    self.dragList:setLocation(0, -75, 0);
end

function Lua_TacticSelectWindow:showWin(param)
    self:superCall("showWin", param);
    self.selectType = param.selectType; -- 1选主战法 2选副战法
    self.heroUid = param.heroUid;
    self.tacticUid = param.tacticUid;
    self.showLock = param.showLock;
    self:updateData();
end

function Lua_TacticSelectWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    self:superCall("dispose");
end

function Lua_TacticSelectWindow:updateData()
    local arr = DataCenter.heroTacticData:getTacticVoArr(self.tacticUid, self.showLock);
    self.dragList:setArrayData(arr);
end

function Lua_TacticSelectWindow:onItemClick(data)
    Lua_WindowUtil.openWin("Lua_TacticTipsWindow", Lua_WinParam.ACTION_OPEN, {data = data, isShowBtns = true, btnType = self.selectType, heroUid = self.heroUid, tacticUid = self.tacticUid});
end

function Lua_TacticSelectWindow:checkCloseWin(heroUid)
    if Lua_WindowUtil.isOpenWin("Lua_TacticDevelopWindow") and self.heroUid ~= heroUid then
        self:updateData();
    else
        self:hide();
    end
end



























Lua_TacticSelectItem = class("Lua_TacticSelectItem", Lua_ListCell);

function Lua_TacticSelectItem:ctor(p)
    self:superCall("ctor", p, "TacticSelectItem_skin");
end

function Lua_TacticSelectItem:buildShowItem()
    self:superCall("buildShowItem");

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setLocation(0, 18, 0);
    self.itemIcon:setSiblingIndex(1);
end

function Lua_TacticSelectItem:dispose()
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self:superCall("dispose");
end

function Lua_TacticSelectItem:setData(data)
    self.data = data;

    self.nameTxt.text = data.tacticName;
    self.itemIcon:setData(data);
    self.itemIcon:showNum(0);
    if not data.isActive then
        self.itemIcon:showStar(nil);
        self.itemIcon:setTacticLv(nil);
    end
    self.maskIcon:setEnable(not data.isActive);
    self.lockIcon:setEnable(not data.isActive);
end

function Lua_TacticSelectItem:onPressClick()
    Lua_MsgUtil.callFunc("ON_TACTIC_SELECT_CLICK", self.data);
end