-- 战法技能Tips Window
checkRequire("Lua_TacticSkillBuffItem");
checkRequire("Lua_TacticSkillTagItem");
checkRequire("Lua_TacticSkillDescItem");
Lua_TacticSkillTipsWindow = class("Lua_TacticSkillTipsWindow", Lua_Window);

function Lua_TacticSkillTipsWindow:ctor()
    self:superCall("ctor");

    self.showBlackMask = true;
    self.isClickClose = true;

    self.windowName = "Lua_TacticSkillTipsWindow";
    self.skinName = "TacticSkillTipsWindow_skin";
end

function Lua_TacticSkillTipsWindow:buildPanel(go)
    self:superCall("buildPanel", go);
end

function Lua_TacticSkillTipsWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.tagItemArr = Array();

    self.dragContainer = Lua_DragContainer.new(self.content, 410, 525, Lua_AxisDefine.Vertical);
    self.dragContainer:setRectPivot(1);
    self.dragContainer:setLocation(0, 192.5, 0);
end

function Lua_TacticSkillTipsWindow:showWin(param)
    self:superCall("showWin", param);

    self.skillVo = param.skillVo;
    self.starNum = param.starNum;

    self.skillIcon:setAltas(self.skillVo.atlas, self.skillVo.sprite);
    self.skillName.text = LanUtil.formateStr(792039, self.skillVo.name, self.skillVo.level);

    local list = self.skillVo.skill_tag;
    local len = list ~= nil and #list or 0;
    local num = self.tagItemArr:getSize();
    local count = len > num and len or num;
    local item;
    local offsetX = 0;
    for i = 1, count do
        item = self.tagItemArr[i];
        if item == nil then
            item = Lua_TacticSkillTagItem.new(self.content);
            self.tagItemArr:add(item);
        end

        if len >= i then
            item:setData(list[i]);
            item:setLocation(-35 + offsetX, 260, 0);
            offsetX = offsetX + item:getWidth();
        end
        item:setEnable(len >= i);
    end

    self.dragContainer.customParam = self.starNum;
    self.dragContainer:addSubContainer(Lua_TacticSkillTipsItem, self.skillVo, true, 5);

    local list = self.dragContainer.showDragDataList;
    local count = self.dragContainer.cellsCount;
    local addHeight = 0;
    for i = 1, count do
        addHeight = addHeight + list[i].cellHeight;
    end

    addHeight = addHeight >= 525 and 0 or 525 - addHeight;
    self.dragContainer:setContentRect(410, 525 - addHeight)
    self.dragContainer:moveToIndex(1, true);
    self.dragContainer.canDrag = not self.dragContainer.isTheEnd;

    self.bg:SetDimensions(433, 731 - addHeight);
end

function Lua_TacticSkillTipsWindow:dispose()
    if self.tagItemArr ~= nil then
        self.tagItemArr:dispose();
        self.tagItemArr = nil;
    end
    if self.dragContainer ~= nil then
        self.dragContainer:dispose();
        self.dragContainer = nil;
    end
    self:superCall("dispose");
end
































Lua_TacticSkillTipsItem = class("Lua_TacticSkillTipsItem", Lua_DragContainerItem);

function Lua_TacticSkillTipsItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_TacticSkillTipsItem:buildShowItem()
    self:superCall("buildShowItem");

    self.desItemArr = Array();
    self.buffItemArr = Array();
end

function Lua_TacticSkillTipsItem:dispose()
    if self.desItemArr ~= nil then
        self.desItemArr:dispose();
        self.desItemArr = nil;
    end
    if self.buffItemArr ~= nil then
        self.buffItemArr:dispose();
        self.buffItemArr = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end

function Lua_TacticSkillTipsItem:setCustomParam(starNum)
    self.starNum = starNum;
end

function Lua_TacticSkillTipsItem:setData(data)
    self.data = data;

    local list = data.unlock_level_list;
    local len = list ~= nil and #list or 0;
    local num = self.desItemArr:getSize();
    local count = len > num and len or num;
    local addHeight = 0;
    for i = 1, count do
        item = self.desItemArr[i];
        if item == nil then
            item = Lua_TacticSkillDescItem.new(self.content);
            item:setRectAnchor(0);
            item:setTxtWidth(400);
            self.desItemArr:add(item);
        end

        if len >= i then
            item:setData(data["des" .. i], LanUtil.formateStr(792010, list[i]), self.starNum >= list[i]);
            item:setLocation(0, -addHeight, 0);
            addHeight = addHeight + item:getHeight();
        end
        item:setEnable(len >= i);
    end

    list = data.buff_list;
    len = list ~= nil and #list or 0;
    num = self.buffItemArr:getSize();
    count = len > num and len or num;
    for i = 1, count do
        item = self.buffItemArr[i];
        if item == nil then
            item = Lua_TacticSkillBuffItem.new(self.content);
            item:setRectAnchor(0);
            item:setTxtWidth(400);
            self.buffItemArr:add(item);
        end

        if len >= i then
            item:setData(list[i]);
            item:setLocation(0, -addHeight, 0);
            addHeight = addHeight + item:getHeight();
        end
        item:setEnable(len >= i);
    end

    self.height = addHeight;
end

function Lua_TacticSkillTipsItem:getWidth()
    return 410;
end

function Lua_TacticSkillTipsItem:getHeight()
    return self.height;
end