-- 战法升星成功 Window
Lua_TacticStarUpWindow = class("Lua_TacticStarUpWindow", Lua_Window);

function Lua_TacticStarUpWindow:ctor()
    self:superCall("ctor");

    self.showBlackMask = true;
    self.isClickClose = true;

    self.windowName = "Lua_TacticStarUpWindow";
    self.skinName = "TacticStarUpWindow_skin";
end

function Lua_TacticStarUpWindow:buildPanel(go)
    self:superCall("buildPanel", go);
end

function Lua_TacticStarUpWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.attrItemArr = Array();

    self.leftItem = Lua_ItemIcon.new(self.content);
    self.leftItem:setScale(0.86, 0.86);
    self.leftItem:setLocation(-150, 131, 0);

    self.rightItem = Lua_ItemIcon.new(self.content);
    self.rightItem:setScale(0.86, 0.86);
    self.rightItem:setLocation(150, 131, 0);

    self.effect = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_shengduan_ziti", "ui_shengduan_ziti", 0, 0);
    self.effect.siblingIndex = 2;
end

function Lua_TacticStarUpWindow:showWin(param)
    self:superCall("showWin", param);

    local tacticVo = DataCenter.packData:getItemVoByUnId(param);
    local itemVo = Lua_ToolVo.createToolVo(tacticVo.id);
    itemVo.tacticLevel = 0;
    itemVo.tacticStar = tacticVo.tacticStar - 1;
    self.leftItem:setData(itemVo);

    local itemVo = Lua_ToolVo.createToolVo(tacticVo.id);
    itemVo.tacticLevel = 0;
    itemVo.tacticStar = tacticVo.tacticStar;
    self.rightItem:setData(itemVo);

    local arr = DataCenter.heroTacticUtil:upstarAttrVoArr(tacticVo.tacticStarId - 1);
    local len = arr:getSize();
    local num = self.attrItemArr:getSize();
    local count = len > num and len or num;
    local item;
    for i = 1, count do
        item = self.attrItemArr[i];
        if item == nil then
            item = Lua_TacticStarUpItem.new(self.content);
            item:setLocation(0, 38 - (i - 1) * 46, 0);
            self.attrItemArr:add(item);
        end

        if len >= i then
            item:setData(arr[i]);
            item:setCellSeqIndex(i);
        end
        item:setEnable(len >= i);
    end

    local height = len * 46;
    local lastSkillId = DataCenter.heroTacticUtil:getSkillId(tacticVo.tacticStarId - 1);
    local skillId = DataCenter.heroTacticUtil:getSkillId(tacticVo.tacticStarId);
    if lastSkillId ~= skillId then
        local skillVo = Lua_SkillConfigData.getConfigData(lastSkillId);
        self.lastSkillSp:setAltas(skillVo.atlas, skillVo.sprite);
        self.lastLvlTxt.text = skillVo.level;

        skillVo = Lua_SkillConfigData.getConfigData(skillId);
        self.curSkillSp:setAltas(skillVo.atlas, skillVo.sprite);
        self.curLvlTxt.text = skillVo.level;

        LuaUtil.setObjPos(self.skillObj, 0, 38 - height - 30, 0);
        height = height + 100;
    end
    self.skillObj:SetActive(lastSkillId ~= skillId);

    self.winBg:SetDimensions(720, 165 + height + 20);
end

function Lua_TacticStarUpWindow:dispose()
    if self.leftItem ~= nil then
        self.leftItem:dispose();
        self.leftItem = nil;
    end
    if self.rightItem ~= nil then
        self.rightItem:dispose();
        self.rightItem = nil;
    end
    if self.effect ~= nil then
        self.effect:dispose();
        self.effect = nil;
    end
    if self.attrItemArr ~= nil then
        self.attrItemArr:dispose();
        self.attrItemArr = nil;
    end
    self:superCall("dispose");
end




























Lua_TacticStarUpItem = class("Lua_TacticStarUpItem", Lua_ListCell);

function Lua_TacticStarUpItem:ctor(p)
    self:superCall("ctor", p, "TacticStarUpItem_skin");
end

function Lua_TacticStarUpItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_TacticStarUpItem:dispose()
    self:superCall("dispose");
end

function Lua_TacticStarUpItem:setData(attrVo)
    self.attrIcon:setAltas("common_altas_2", attrVo.hero_attr_icon);
    self.attrName.text = attrVo.show_name;
    self.lastValue.text = attrVo.showValue;
    self.curValue.text = attrVo.showNextValue;
end

function Lua_TacticStarUpItem:setCellSeqIndex(idx)
    self:superCall("setCellSeqIndex", idx);
    self.bg:setEnable(idx % 2 == 0);
end

