-- 战法升星预览 Window
Lua_TacticStarViewWindow = class("Lua_TacticStarViewWindow", Lua_Window);

function Lua_TacticStarViewWindow:ctor()
    self:superCall("ctor");

    self.showBlackMask = true;
    self.isClickClose = true;

    self.windowName = "Lua_TacticStarViewWindow";
    self.skinName = "TacticStarViewWindow_skin";
end

function Lua_TacticStarViewWindow:buildPanel(go)
    self:superCall("buildPanel", go);
end

function Lua_TacticStarViewWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.dragList = Lua_DragList.new(self.content, 622, 656, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_TacticStarViewItem, 622, 212, 1);
    self.dragList:setCellSpacing(0, 10);
    self.dragList:setLocation(0, -20, 0);
end

function Lua_TacticStarViewWindow:showWin(param)
    self:superCall("showWin", param);

    local index = 1;
    local arr = Array();
    for i = param.min_star, param.max_star do
        if i == param.tacticStar then
            index = i;
        end
        arr:add({star = i, curStar = param.tacticStar, maxStar = param.max_star, id = param.id});
    end
    self.dragList:setArrayData(arr);
    self.dragList:moveToIndex(index, true);
end

function Lua_TacticStarViewWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    self:superCall("dispose");
end






















Lua_TacticStarViewItem = class("Lua_TacticStarViewItem", Lua_ListCell);

function Lua_TacticStarViewItem:ctor(p)
    self:superCall("ctor", p, "TacticStarViewItem_skin");
end

function Lua_TacticStarViewItem:buildShowItem()
    self:superCall("buildShowItem");

    self.starArr = Array();
    self.propArr = Array();
end

function Lua_TacticStarViewItem:dispose()
    if self.starArr ~= nil then
        self.starArr:dispose();
        self.starArr = nil;
    end
    if self.propArr ~= nil then
        self.propArr:dispose();
        self.propArr = nil;
    end
    self:superCall("dispose");
end

function Lua_TacticStarViewItem:setData(data)
    local len = self.starArr:getSize();
    local count = len > data.maxStar and len or data.maxStar;
    local item;
    local starWidth = 42;
    for i = 1, count do
        item = self.starArr[i];
        if item == nil then
            item = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_common_label_15", 0, 0, 0, 0);
            self.starArr:add(item);
        end

        if data.maxStar >= i then
            if data.star >= i then
                item:setAltas("common_altas_4", "xui_common_label_15");
            else
                item:setAltas("common_altas_4", "xui_common_label_32");
            end
            item:resetSize();
            item:setLocation((i - 1) * starWidth - (data.maxStar - 1) / 2 * starWidth, 65, 0);
        end
        item:setEnable(data.maxStar >= i);
    end

    local id = data.id * 100 + data.star;
    local arr = DataCenter.heroTacticUtil:getAttrVoArr(nil, id);
    local num = arr:getSize();
    len = self.propArr:getSize();
    count = len > num and len or num;
    for i = 1, count do
        item = self.propArr[i];
        if item == nil then
            item = Lua_TacticStarViewAttrItem.new(self.content);
            item:setLocation(-150 + (i - 1) % 2 * 300, 10 - Mathf.Floor((i - 1) / 2) * 45, 0);
            self.propArr:add(item);
        end

        if num >= i then
            item:setData(arr[i]);
        end
        item:setEnable(num >= i);
    end

    self.nowIcon:setEnable(data.star == data.curStar);
end












Lua_TacticStarViewAttrItem = class("Lua_TacticStarViewAttrItem", Lua_DisplayObject);

function Lua_TacticStarViewAttrItem:ctor(p)
    self:superCall("ctor", p, "TacticStarViewAttrItem_skin");
end

function Lua_TacticStarViewAttrItem:buildShowItem()
    self:superCall("buildShowItem");

    self.attrItem = Lua_TacticAttributeItem.new(self.content, 4);
    self.attrItem:setLocation(-110, 0, 0);
end

function Lua_TacticStarViewAttrItem:setData(attrVo)
    self.attrItem:setData(attrVo);
end

function Lua_TacticStarViewAttrItem:dispose()
    if self.attrItem ~= nil then
        self.attrItem:dispose();
        self.attrItem = nil;
    end
    self:superCall("dispose");
end