--战技背包
Lua_TalentPackPanel = class("Lua_TalentPackPanel", Lua_DisplayObject);
function Lua_TalentPackPanel:ctor(p)
    self:superCall("ctor", p,"TalentPackPanel_skin");
end

function Lua_TalentPackPanel:buildShowItem()
    self:superCall("buildShowItem");
    self.dragList = Lua_DragList.new(self.content,634, 533, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_TalentPackCell, 114, 140, 5);
    self.dragList:setCellSpacing(16, 7);
    self.dragList:setLocation(0, 38);
    
    self.textArea = Lua_TextArea.new(self.show_obj, 323, 78);
    self.textArea:setLocation(-14, -347, 0);

    self.study_btn:addClickFuntion(self, self.onStudyBtnClick);
    self.skill_icon:addClickFuntion(self, self.onSkillBtnClick);

    self:addLuaEvent("ON_SELECT_TALENT_PACK", self, self.selectTalent);
end

function Lua_TalentPackPanel:updateShowInfo(param)
    self.showData = param;
    self.part = param.part;
    self.hvo = param.hvo;
    self.hero_uid = param.hvo.unique_id;
    self.talent_list = param.hvo.talent_list;

    local arr = DataCenter.talentData:getTalentSealInfo(2);
    self.dragList:setArrayData(arr);
    if arr:getSize() > 0 then
        self.bg:SetDimensions(634,552);
        self.des:setLangValue(126863);
        LuaUtil.setObjPos(self.show_tips, 0,-314, 0);
    else
        self.bg:SetDimensions(634,695);
        self.des:setLangValue(126864);
        LuaUtil.setObjPos(self.show_tips, 0,-35, 0);
    end

    self:updateShowTips(true);
end

function Lua_TalentPackPanel:selectTalent(data)
    self.talent_id = data.data.talent_id;
    self.talent_data = Lua_TalentConfigData.getConfigData(self.talent_id);

    local skill_vo = self.talent_data.skill_vo;
    self.skill_icon:setAltas(skill_vo.atlas, skill_vo.sprite);
    self.skill_name.text = skill_vo.name;

    self.textArea:setText("<color=#595959>"..skill_vo.des.."</color>", 22);
    self:updateShowTips(false);
end

function Lua_TalentPackPanel:updateShowTips(bool)
    self.show_tips:SetActive(bool);
    self.show_obj:SetActive(not bool);
end

--战技学习
function Lua_TalentPackPanel:onStudyBtnClick()
    local list = self.hvo.talent_info;
    for i=1,#list do
        if tonumber(list[i].value) ~= 0 then
            local _type = Lua_TalentConfigData.getConfigData(tonumber(list[i].value)).type;
            if _type == self.talent_data.type then
                OperateAlert.showLangValue(126862);
                return;
            end
        end
    end

    Lua_ProxyManager.getProxy("Lua_TalentProxy"):sTalentStudy(self.hero_uid, self.part, self.talent_id, 2);
    Lua_WindowUtil.openWin("Lua_TalentStudyWindow", Lua_WinParam.ACTION_CLOSE);
end

--技能tips
function Lua_TalentPackPanel:onSkillBtnClick()
    if self.talent_data.skill_vo ~= nil then
        Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.talent_data.skill_vo);
    end
end

function Lua_TalentPackPanel:dispose()
    if self.dragList == nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    if self.textArea ~= nil then
        self.textArea:dispose();
        self.textArea = nil;
    end
    self.showData = nil;
    self:superCall("dispose");
end
















Lua_TalentPackCell = class("Lua_TalentPackCell", Lua_ListCell);
function Lua_TalentPackCell:ctor(p)
    self:superCall("ctor", p, "TalentStudyCell_skin");
end

function Lua_TalentPackCell:buildShowItem()
    self:superCall("buildShowItem");
    self.select_bg:setEnable(false);
end

function Lua_TalentPackCell:setData(data)
    self.data = data;
    
    local id = data.data.talent_id;
    local talent_data  = Lua_TalentConfigData.getConfigData(id);
    local skill_vo = talent_data.skill_vo;
    if skill_vo ~= nil then
        self.skill_icon:setAltas(skill_vo.atlas, skill_vo.sprite);
    end

    local name = data.data.name;
    if name == nil then
        name = talent_data.name;
    end
    self.skill_name.text = name;

    self.study_spr:setEnable(false);
    self:updateSelect()
end

function Lua_TalentPackCell:updateSelect()
    self.select_bg:setEnable(self.data.isSelect);
end

function Lua_TalentPackCell:onPressClick()
    Lua_MsgUtil.callFunc("ON_SELECT_TALENT_PACK", self.data);
    return true;
end

function Lua_TalentPackCell:onSelectionChange(bSelect)
    self:superCall("onSelectionChange", bSelect);
    self.data.isSelect = bSelect;
    self:updateSelect();
end

function Lua_TalentPackCell:dispose()
    self.data = nil;
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self:superCall("dispose");
end