--战技升级
Lua_TalentUpgradeWindow = class("Lua_TalentUpgradeWindow", Lua_Window);
function Lua_TalentUpgradeWindow:ctor()
    self:superCall("ctor");
    self.showClose = false;
    self.isClickClose = true;
    self.showBlackMask = true;
    self.windowName = "Lua_TalentUpgradeWindow";
    self.skinName="TalentUpgradeWindow_skin";
end

function Lua_TalentUpgradeWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.skill_shop:setLocation(-150,-393,0);
    self.skill_seal:setLocation(150,-393,0);
    self.skill_forget:setEnable(false);--屏蔽遗忘按钮
    

    self.skill_icon_L:addClickFuntion(self, self.onSkill1BtnClick);
    self.skill_icon_R:addClickFuntion(self, self.onSkill2BtnClick);

    self.skill_shop:addClickFuntion(self, self.onShopBtnClick);--商店
    self.skill_seal:addClickFuntion(self, self.onSealBtnClick);--封装
    self.skill_forget:addClickFuntion(self, self.onForgetBtnClick);--遗忘
    self.skill_upgarde:addClickFuntion(self, self.onUpgardeBtnClick);--升级

    self:addLuaEvent("UPDATE_TALENT_UDGRADE_INF", self, self.updateUpgradeInfo);
end

function Lua_TalentUpgradeWindow:showWin(param)
    self:superCall("showWin",param);
    -- param.part --部位
    -- param.hero_uid--英雄唯一id
    self.part = param.part;
    self.hero_uid = param.hero_uid;
    self:updateUpgradeInfo(param.talent_id)
end

function Lua_TalentUpgradeWindow:updateUpgradeInfo(id)
    self.talent_data = Lua_TalentConfigData.getConfigData(id);
    
    local isMaxLevel = self.talent_data.next_id == nil or self.talent_data.next_id == 0;
    if isMaxLevel == true then--满级
        self:showUpgradeCost(nil);
        self.left_obj:SetActive(false);
        self.show_tips:SetActive(true);
        self.skill_upgarde:setEnable(false);
        LuaUtil.setObjPos(self.right_obj, 0, 107, 0);

        self.skill_vo1 = self.talent_data.skill_vo;
        self.skill_name_R.text = self.skill_vo1.name;
        self.skill_des_R.text = self.skill_vo1.des;
        self.skill_icon_R:setAltas(self.skill_vo1.atlas, self.skill_vo1.sprite);
    else
        self.skill_vo = self.talent_data.skill_vo;
        self.skill_name_L.text = self.skill_vo.name;
        self.skill_des_L.text = self.skill_vo.des;
        self.skill_icon_L:setAltas(self.skill_vo.atlas, self.skill_vo.sprite);

        local next_data = Lua_TalentConfigData.getConfigData(self.talent_data.next_id);
        self.skill_vo1 = next_data.skill_vo;
        self.skill_name_R.text = self.skill_vo1.name;
        self.skill_des_R.text = self.skill_vo1.des;
        self.skill_icon_R:setAltas(self.skill_vo1.atlas, self.skill_vo1.sprite);

        self.left_obj:SetActive(true);
        self.show_tips:SetActive(false);
        self.skill_upgarde:setEnable(true);
        LuaUtil.setObjPos(self.right_obj, 174, 107, 0);
        self:showUpgradeCost(self.talent_data.upgarde_cost);
    end
    

    local showState = DataCenter.talentData:talentUpgradeRedDot(id);
    self:showRedDot(showState);
end

--升级红点
function Lua_TalentUpgradeWindow:showRedDot(val)
    if val == true then
        if self.redDotIcon == nil then
            self.redDotIcon = Lua_RedPointIcon.new(self.content);
            self.redDotIcon:setLocation(60, -266, 0);
            self.redDotIcon:createRedPointImg(nil);
        end
        self.redDotIcon:updateRedPointShow(true);
    else
        if self.redDotIcon ~= nil then
            self.redDotIcon:updateRedPointShow(false);
        end
    end
end

function Lua_TalentUpgradeWindow:showUpgradeCost(list)
    if list ~= nil then
        if self.costInfo == nil then
            self.costInfo = Array();
        end
        local len = self.costInfo:getSize();
        for i = 1, len do
            self.costInfo[i]:setEnable(false);
        end
        local w = 262;
        for i=1,#list do
            local item = nil;
            if self.costInfo[i] ~= nil then
                item = self.costInfo[i];
            else
                item = Lua_TalentCostItem.new(self.content);
                self.costInfo:add(item);
            end
            item:setData(list[i]);
            item:setLocation(-1 * w * #list / 2 + w * (i-1) + w / 2, -190, 0);
            item:setEnable(true);
        end
    else
        if self.costInfo ~= nil then
            for i=1,self.costInfo:getSize() do
                self.costInfo[i]:setEnable(false);
            end
        end
    end
end

-- 升级
function Lua_TalentUpgradeWindow:onUpgardeBtnClick()
    local list = self.talent_data.upgarde_cost;
    local id;
    for i=1,#list do
        local need_num = list[i][2];
        local have_num = DataCenter.packData:getItemCountById(list[i][1]);
        if need_num > have_num then
            id = list[i][1];
            break;
        end
    end
	if id ~= nil then
        DataCenter.packUtil:openPathWindow(id, false);
        return;
    end
    Lua_ProxyManager.getProxy("Lua_TalentProxy"):sTalentUpgrade(self.hero_uid, self.part);
end

-- 商店
function Lua_TalentUpgradeWindow:onShopBtnClick()
    Lua_WindowUtil.openWin("Lua_ShopWindow", Lua_WinParam.ACTION_OPEN, 1001);
end

-- 封装
function Lua_TalentUpgradeWindow:onSealBtnClick()
    local info = self.talent_data.pack_cost;
    local str = spliceIconStrById(info[1][1]);
    local tipsData = {
        h = 443,
        titleAtlas = "hero_atlas_3",
        titleSprite = "ui_zj_title_01",
        des = LanUtil.formateStr(126861, self.talent_data.name, str, tostring(info[1][2])),
        posY = 60,
        btnType = 1,
        owner = self,
        sureFun = self.sendSeal
    };
    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipsData);
end

-- 封装
function Lua_TalentUpgradeWindow:sendSeal()
    local need_num = self.talent_data.pack_cost[1][2];
    local have_num = DataCenter.packData:getItemCountById(self.talent_data.pack_cost[1][1]);
    if need_num > have_num then
        DataCenter.packUtil:openPathWindow(self.talent_data.pack_cost[1][1], false);
        return;
    end
    Lua_ProxyManager.getProxy("Lua_TalentProxy"):sTalentSeal(self.hero_uid, self.part);
    self:hide();
end

-- 遗忘
function Lua_TalentUpgradeWindow:onForgetBtnClick()
    local info1 = self.talent_data.forget_cost;
    local info2 = self.talent_data.forget_obtain;
    local str = spliceIconStrById(info1[1][1]);
    
    local tipsData = {
        h = 443,
        des = LanUtil.formateStr(126860, str, tostring(info1[1][2])),
        posY = 70,
        secDes = LanUtil.formateStr(126867, str, tostring(info2[1][2])),
        secDesPosY = 27,
        btnType = 1,
        owner = self,
        sureFun = self.sendForget
    };
    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipsData);
end

-- 遗忘
function Lua_TalentUpgradeWindow:sendForget()
    local need_num = self.talent_data.forget_cost[1][2];
    local have_num = DataCenter.packData:getItemCountById(self.talent_data.forget_cost[1][1]);
    if need_num > have_num then
        DataCenter.packUtil:openPathWindow(self.talent_data.forget_cost[1][1], false);
        return;
    end

    Lua_ProxyManager.getProxy("Lua_TalentProxy"):sTalentForget(self.hero_uid, self.part);
    self:hide();
end

function Lua_TalentUpgradeWindow:onSkill1BtnClick()
    if self.skill_vo ~= nil then
        Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.skill_vo);
    end
end

function Lua_TalentUpgradeWindow:onSkill2BtnClick()
    if self.skill_vo1 ~= nil then
        Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.skill_vo1);
    end
end

function Lua_TalentUpgradeWindow:dispose()
    if self.costInfo ~= nil then
        self.costInfo:dispose();
        self.costInfo:clear()
        self.costInfo = nil;
    end
    if self.redDotIcon ~= nil then
        self.redDotIcon:dispose();
        self.redDotIcon = nil;
    end
    self:superCall("dispose");
end






-- 动态显示item
Lua_TalentCostItem = class("Lua_TalentCostItem", Lua_DisplayObject);
function Lua_TalentCostItem:ctor(p)
    self:superCall("ctor", p,"TalentCostItem_skin");
end

function Lua_TalentCostItem:buildShowItem()
    self:superCall("buildShowItem");
    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setLocation(-55, 0, 0);
    self.itemIcon:setCanClick(true);
end

function Lua_TalentCostItem:setData(data)
    local tvo = Lua_ToolVo.new(data[1]);
    self.itemIcon:setData(tvo);

    local need_num = data[2];
    local have_num = DataCenter.packData:getItemCountById(data[1]);
    if have_num < need_num then
        have_num = "<color=#da1f1f>"..numberTrans(have_num).."</color>";
    else
        have_num = "<color=#16a803>"..numberTrans(have_num).."</color>";
    end
    self.num.text = have_num.."/"..numberTrans(need_num);
    self.name.text = tvo.name;
end

function Lua_TalentCostItem:dispose()
    self:superCall("dispose");
end